#ifndef BREAKPOINTL_H_INCLUDED
#define BREAKPOINTL_H_INCLUDED

#include "pc6001v.h"


////////////////////////////////////////////////////////////////
// NX`
////////////////////////////////////////////////////////////////
#ifdef USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
// u[N|Cg̐
#define	NR_BP	(10)

class BPoint {
public:
	enum BPtype{ BP_NONE, BP_PC, BP_READ, BP_WRITE, BP_IN, BP_OUT, EndofBPtype };
	
private:
	typedef struct{
		BPtype Type;
		WORD Addr;
	} BreakPoint;
	BreakPoint BP[NR_BP];	// u[N|Cg
	
	// u[N|Cg̏
	int BPNo;
	WORD BPAddr;
	BYTE BPData;
	char *BPStr;
	
	// u[Nv
	BOOL ReqBreak;
	int ReqBPNum;
	
public:
	BPoint();
	~BPoint();
	
	BOOL ExistBreakPoint();								// u[N|Cg̗L`FbN
	BOOL CheckBreakPoint( BPtype, WORD, BYTE, char * );	// u[N|Cg`FbN
	
	void ClearStatus();									// u[N|Cg̏NA
	
	BPtype GetType( int );								// u[N|Cg̃^Cv擾
	WORD GetAddr( int );								// u[N|Cg̃AhX擾
	void SetType( int, BPtype );						// u[N|Cg̃^Cvݒ
	void SetAddr( int, WORD );							// u[N|Cg̃AhXݒ
	
	BOOL IsReqBreak();									// u[Nv?
	int GetReqBPNum();									// u[Nv̂u[N|CgNo.擾
	void ResetBreak();									// u[NvLZ
};

#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //

#endif	// BREAKPOINTL_H_INCLUDED
