// OSˑ̔ėp[`(UIp)
// ɍ킹ĕR[hύX邱
//  Windows : ShiftJIS
//  Unix    : EUC


#ifdef __APPLE__
///////////////////////////////////////////////////////////
// GUI for Mac by Koichi Nishida 2004/10/17, 2005/5/25
///////////////////////////////////////////////////////////

#include <new>
#include <Carbon/Carbon.h>

//#include "SDL_syswm.h"

#include "breakpoint.h"
#include "disk.h"
#include "error.h"
//#include "global.h"
#include "graph.h"
#include "ini.h"
#include "mc6847.h"
#include "memory.h"
#include "movie.h"
#include "osd.h"
#include "p6v.h"
#include "pc60.h"
#include "schedule.h"
#include "tape.h"

#ifndef REVISION
#define REVISION "REVISION ??"
#endif

#define APP_SIGNATURE 'P60V'	// Ƃ肠AvP[VVOl` P60V
#define TAB_ID			128		// ^u ( yC 129 - 136 )    Ver.1.09 ŁA127ǉ

#define MACHINE_ID		137		// @
#define FDD_NUM_ID		138		// FDD
#define USE_EXT_RAM_ID	139		// gRAM
#define USE_SOL_CAT_ID  140     // m̃J[gbWg


// 
#define SCR_BPP_ID		300		// J[[h@bpp
#define MODE4_COL_ID	305		// [hSJ[
#define FRAME_SKIP_ID   310		// t[XLbv		u PDOW@@v
#define DISP_SCAN_ID	315		// XLC\
#define SCAN_LEVEL_ID	320		// XLCPx
#define DISP_NTSC_ID    325     // 4:3\
#define FULLSCREEN_ID   330     // tXN[
#define DISP_STATUS_ID  335     // Xe[^Xo[\


// TEh
#define SAMPLE_RATE_ID	400		// TvO[g
#define MASTER_VOL_ID	405		// }X^[
#define PSG_VOL_ID		410		// PSG
#define VOICE_VOL_ID	415		// 
#define TAPE_MON_VOL_ID	420		// e[vj^
#define BUFF_SIZE_ID	425		// obt@TCY
#define CUT_LPF_ID      430     // PSG [pXtB^@JbgItg

// 
#define KEY_REP_ID		500		// L[s[gԊu

// t@C
#define EXT_ROM_FI_ID	600		// gROM
#define TAPE_LOAD_FI_ID	605		// TAPE(LOAD)
#define TAPE_SAVE_FI_ID	610		// TAPE(SAVE)
#define DISK_FI_ID		615		// DISK
#define PRINTER_FI_ID	620		// v^
#define Z_FONT_FI_ID	625		// SptHg
#define H_FONT_FI_ID	630		// ptHg

// tH_
#define ROM_FO_ID		700		// ROM
#define TAPE_FO_ID		705		// TAPE
#define DISK_FO_ID		710		// DISK
#define EXT_ROM_FO_ID	715		// gROM
#define SNAP_FO_ID		720		// SnapShot
#define WAVE_FO_ID		725		// WAVE
#define FONT_FO_ID		730		// tHg


#define  COLOR16_ID		167		// F@@@@@@@@FɁA167ǉ@@@@Ver.1.08  Windy   2006/1/9
#define COLOR17_ID		168		//
								// ...
#define COLOR64_ID		215

// ̑
#define OVERCLOCK_ID	900		// I[o[NbN
#define CRC_CHECK_ID	905		// VXeROMCRC`FbNL    167225ɕύX    Ver.1.08 Windy 2006/1/9
#define PATCH_ROM_ID    910     // ROM Ƀpb`𓖂Ă (oOC)
#define TURBO_TAPE_ID	915		// Turbo TAPE
#define BOOSTUP_ID		920		// Boost Up   Ver.1.08  Windy 2006/1/9 
#define MAXBOOST60_ID   925		// ő{@@N60
#define MAXBOOST62_ID   930		// ő{ @mUO/N66
#define AVIRLE_ID		935		// rfILv` Run-Length encoding

#define CHK_QUIT_ID     940     // IɊmF
#define SAVE_INI_ID     945     // IINIt@Cۑ

// ݒf[^x[X
static cIni *Ini = NULL;

// ݒEBhE
static WindowRef confWin;

// o[WEBhE
static WindowRef aboutWin;		// add Windy 2006/1/22

// |bvAbvj[̃Cxgnh
static pascal OSStatus popupMenuEventHandler( EventHandlerCallRef inHandlerRef,
	EventRef inEvent, void *userData );
bool ShowConfig( IBNibRef nibRef, char *initpath );  // ݒvpeBV[g\

// o[W			
bool ShowAbout( IBNibRef nibRef, char *initpath );

///////////////////////////////////////////////////////////
// dȂɃO[oϐ
///////////////////////////////////////////////////////////
static cConfig *ccfg = NULL;	// ݒIuWFNg|C^
static cConfig *ecfg = NULL;	// ݒIuWFNg|C^(ҏWp)



// |bvAbvj[\
void VM6::ShowPopupMenu( int x, int y )
{
	OSStatus err;
	IBNibRef nibRef;
	EventHandlerRef popupHandler;	
	SInt32 menuCom = 0;
	EventTypeSpec mainSpec = { kEventClassCommand, kEventCommandProcess };
	MenuRef menu, tmpMenu;
	MenuItemIndex tmpIdx;
	EventHandlerUPP popupUPP;
	
	// }EẌʒu𓾂iƂx, yl͎gȂj
	Point pt;
	GetGlobalMouse( &pt );
	x = pt.v; y = pt.h;
	

	// Nibt@CJ
	err = CreateNibReference ( CFSTR("main"), &nibRef );
	require_noerr( err, CreateNibError );

	// |bvAbvCxgnhCXg[
	popupUPP = NewEventHandlerUPP( popupMenuEventHandler );
	err = InstallApplicationEventHandler( popupUPP, 1, &mainSpec,
		(void *)&menuCom, &popupHandler);
	require_noerr( err, PopupInstallError );

	// |bvAbvj[
	err = CreateMenuFromNib( nibRef, CFSTR( "Menu" ), &menu );
	require_noerr( err, CreateMenuError );

	// j[̑O
	
	// j[ACefBXGCuɂɂ́ADisableMenuCommand ŏôŊȒPB
	// j[ACe폜A`FbNɂ́AGetIndMenuItemWithCommandID
	// ŃR}h ID Tuj[ƃCfbNXɕϊȂ΂ȂȂB
	// Interface Builder Ŏw肵j[ ID ł͍폜A`FbNłȂB
	
	// rfILv`			Ver.1.08  Windy  2006/1/2
	{
	char  tmpstr[256];   // c String to Pascal String
	sprintf(tmpstr,".%s", (char *)(AVI6::IsAVI() ? MSMEN_AVI1 : MSMEN_AVI0));
	tmpstr[0]= strlen( (AVI6::IsAVI() ? MSMEN_AVI1 : MSMEN_AVI0));
	
	err = GetIndMenuItemWithCommandID( menu, 'Avic', 1, &tmpMenu, &tmpIdx );
	require_noerr( err, PopupMenuError );		
	SetMenuItemText( tmpMenu , tmpIdx, (unsigned char*)tmpstr);
	}

	// j^[h or u[N|C^ݒ肳ĂrfILv`
	if( cfg->GetMonDisp()  || bp->ExistBreakPoint() ) 
		DisableMenuCommand ( menu ,'Avic');
	else
		EnableMenuCommand  ( menu, 'Avic');


 
 	// vCL^         Ver.1.10
	{
	char  tmpstr[256];   // c String to Pascal String
    char  *p;
    p = (char *)(( REPLAY::GetStatus() == REP_RECORD ) ? MSMEN_REP1 : MSMEN_REP0);
	sprintf(tmpstr,".%s", (char *)p );
	tmpstr[0]= strlen( p );
	
	err = GetIndMenuItemWithCommandID( menu, 'Rsav', 1, &tmpMenu, &tmpIdx );
	require_noerr( err, PopupMenuError );		
	SetMenuItemText( tmpMenu , tmpIdx, (unsigned char*)tmpstr);

	// j^[h or u[N|C^ݒ肳Ă
	// ܂̓vCĐ烊vCL^
	if( cfg->GetMonDisp() || bp->ExistBreakPoint() || ( REPLAY::GetStatus() == REP_REPLAY ) )
        DisableMenuCommand( menu , 'Rsav');
    else
        EnableMenuCommand( menu , 'Rsav');
	}

	// vCĐ
	{
	char  tmpstr[256];   // c String to Pascal String
    char  *p;
    p = (char *)(( REPLAY::GetStatus() == REP_REPLAY ) ? MSMEN_REP3: MSMEN_REP2);
	sprintf(tmpstr,".%s", (char *)p );
	tmpstr[0]= strlen( p );
	
	err = GetIndMenuItemWithCommandID( menu, 'Rply', 1, &tmpMenu, &tmpIdx );
	require_noerr( err, PopupMenuError );		
	SetMenuItemText( tmpMenu , tmpIdx, (unsigned char*)tmpstr);
	// j^[h or u[N|C^ݒ肳Ă
	// ܂̓vCL^烊vCĐ
	if( cfg->GetMonDisp() || bp->ExistBreakPoint() || ( REPLAY::GetStatus() == REP_RECORD ) )
        DisableMenuCommand( menu , 'Rply');
    else
        EnableMenuCommand( menu , 'Rply');
    }


/* 	
 	// vCL^         Ver.1.10
	minfo.fMask      = MIIM_TYPE;
	minfo.dwTypeData = NULL;
	GetMenuItemInfo( hsm, ID_REPLAYSAVE, MF_BYCOMMAND, &minfo );
	minfo.dwTypeData = (char *)(( REPLAY::GetStatus() == REP_RECORD ) ? MSMEN_REP1 : MSMEN_REP0);
	SetMenuItemInfo( hsm, ID_REPLAYSAVE, MF_BYCOMMAND, &minfo );
	// j^[h or u[N|C^ݒ肳Ă
	// ܂̓vCĐ烊vCL^
	if( cfg->GetMonDisp() || bp->ExistBreakPoint() || ( REPLAY::GetStatus() == REP_REPLAY ) )
		EnableMenuItem( hsm, ID_REPLAYSAVE, MF_BYCOMMAND | MF_GRAYED );
	
	// vCĐ
	minfo.fMask      = MIIM_TYPE;
	minfo.dwTypeData = NULL;
	GetMenuItemInfo( hsm, ID_REPLAYLOAD, MF_BYCOMMAND, &minfo );
	minfo.dwTypeData = (char *)(( REPLAY::GetStatus() == REP_REPLAY ) ? MSMEN_REP3: MSMEN_REP2);
	SetMenuItemInfo( hsm, ID_REPLAYLOAD, MF_BYCOMMAND, &minfo );
	// j^[h or u[N|C^ݒ肳Ă
	// ܂̓vCL^烊vCĐ
	if( cfg->GetMonDisp() || bp->ExistBreakPoint() || ( REPLAY::GetStatus() == REP_RECORD ) )
		EnableMenuItem( hsm, ID_REPLAYLOAD, MF_BYCOMMAND | MF_GRAYED );
*/	
 	

 
 
 
	// TAPE
	*cmt->GetFile() ? EnableMenuCommand( menu, 'Teje' ) : DisableMenuCommand( menu, 'Teje' );
	// DISK
	switch ( disk->GetDrives() ) {
	case 0:
		DeleteMenuItem( menu, 4 );
		break;
	case 1:
		err = GetIndMenuItemWithCommandID( menu, 'Drv2', 1, &tmpMenu, &tmpIdx );
		require_noerr( err, PopupMenuError );		
		DeleteMenuItem( tmpMenu, tmpIdx );
		*disk->GetFile(0) ? EnableMenuCommand( menu, 'D1ej' ) : DisableMenuCommand( menu, 'D1ej' );
		break;
	default:
		*disk->GetFile( 0 ) ? EnableMenuCommand( menu, 'D1ej' ) : DisableMenuCommand( menu, 'D1ej' );
		*disk->GetFile( 1 ) ? EnableMenuCommand( menu, 'D2ej' ) : DisableMenuCommand( menu, 'D2ej' );
	}
	// gROM
	//*cGlobal::ExtRomFile ? EnableMenuCommand( menu, 'Reje' ) : DisableMenuCommand( menu, 'Reje' );
	*mem->GetFile() ? EnableMenuCommand( menu, 'Reje' ) : DisableMenuCommand( menu, 'Reje' );   // by windy

	// [hSJ[
	err = GetIndMenuItemWithCommandID( menu, 'M4mn', 1, &tmpMenu, &tmpIdx );	
	require_noerr( err, PopupMenuError );		
	CheckMenuItem( tmpMenu, tmpIdx,  vdg->GetMode4Color() == 0 ? true : false );
	err = GetIndMenuItemWithCommandID( menu, 'M4rb', 1, &tmpMenu, &tmpIdx );
	require_noerr( err, PopupMenuError );		
	CheckMenuItem( tmpMenu, tmpIdx,  vdg->GetMode4Color() == 1 ? true : false );
	err = GetIndMenuItemWithCommandID( menu, 'M4br', 1, &tmpMenu, &tmpIdx );
	require_noerr( err, PopupMenuError );		
	CheckMenuItem( tmpMenu, tmpIdx,  vdg->GetMode4Color() == 2 ? true : false );
	err = GetIndMenuItemWithCommandID( menu, 'M4pg', 1, &tmpMenu, &tmpIdx );
	require_noerr( err, PopupMenuError );		
	CheckMenuItem( tmpMenu, tmpIdx,  vdg->GetMode4Color() == 3 ? true : false );
	err = GetIndMenuItemWithCommandID( menu, 'M4gp', 1, &tmpMenu, &tmpIdx );
	require_noerr( err, PopupMenuError );		
	CheckMenuItem( tmpMenu, tmpIdx,  vdg->GetMode4Color() == 4 ? true : false );

	// t[XLbv			Ver.1.08 2006/1/2  Windy
	{
	 long unsigned int menucmd[6]={'fsk0','fsk1','fsk2','fsk3','fsk4','fsk5'};
	 err = GetIndMenuItemWithCommandID( menu, menucmd[cfg->GetFrameSkip()], 1, &tmpMenu, &tmpIdx );	
	 require_noerr( err, PopupMenuError );		
	 CheckMenuItem( tmpMenu, tmpIdx, true );
	}

	// EFCg
	err = GetIndMenuItemWithCommandID( menu, 'Nowt', 1, &tmpMenu, &tmpIdx );
	require_noerr( err, PopupMenuError );
	CheckMenuItem( tmpMenu, tmpIdx, sche->GetWaitEnable() ? false : true );
	// Turbo TAPE
	err = GetIndMenuItemWithCommandID( menu, 'Tbtp', 1, &tmpMenu, &tmpIdx );
	require_noerr( err, PopupMenuError );
	CheckMenuItem( tmpMenu, tmpIdx, cfg->GetTurboTAPE() ? true : false );

	// Boost UP            Ver.1.08 2006/1/1  Windy
	err = GetIndMenuItemWithCommandID( menu, 'Bstp', 1, &tmpMenu, &tmpIdx );
	require_noerr( err, PopupMenuError );
	CheckMenuItem( tmpMenu, tmpIdx,  cmt->IsBoostUp() ? true : false );

	// XLC
	err = GetIndMenuItemWithCommandID( menu, 'Slin', 1, &tmpMenu, &tmpIdx );
	require_noerr( err, PopupMenuError );	
	CheckMenuItem( tmpMenu, tmpIdx, cfg->GetScanLine() ? true : false );

	// 4:3 \
	err = GetIndMenuItemWithCommandID( menu, 'Ntsc', 1, &tmpMenu, &tmpIdx );
	require_noerr( err, PopupMenuError );
	CheckMenuItem( tmpMenu, tmpIdx, cfg->GetDispNTSC()   ? true : false );

	// Xe[^Xo[
	err = GetIndMenuItemWithCommandID( menu, 'Stbr', 1, &tmpMenu, &tmpIdx );
	require_noerr( err, PopupMenuError );
	CheckMenuItem( tmpMenu, tmpIdx, cfg->GetStatDisp() ? true : false );
	
	#ifdef USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	err = GetIndMenuItemWithCommandID( menu, 'Mmod', 1, &tmpMenu, &tmpIdx );
	require_noerr( err, PopupMenuError );
	CheckMenuItem( tmpMenu, tmpIdx, cfg->GetMonDisp() ? true: false );
	err = GetIndMenuItemWithCommandID( menu, 'Ptim', 1, &tmpMenu, &tmpIdx );
	require_noerr( err, PopupMenuError );
	CheckMenuItem( tmpMenu, tmpIdx, cfg->GetTimerIntr() ? false: true );
	#else
	err = GetIndMenuItemWithCommandID( menu, 'Dbug', 1, &tmpMenu, &tmpIdx );
	require_noerr( err, PopupMenuError );	
	DeleteMenuItem( tmpMenu, tmpIdx );
	#endif			// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	
	// |bvAbvj[\AR}hQbg
	PopUpMenuSelect( menu, x, y, 0 );
	
	char str[PATH_MAX];
	switch( menuCom ){
	case 'Tins':		// TAPE }
		if( OSD_FileSelect( NULL, FD_TapeLoad, str, cfg->GetTapePath() ) )
		if( !TapeInsert( str ) ) Error::SetError( Error::TapeMountFailed );
		break;
		
	case 'Teje':		// TAPE ro
		TapeEject();
		break;
		
	case 'D1in':		// DISK1 }
		if( OSD_FileSelect( NULL, FD_Disk, str, cfg->GetDiskPath() ) )
		if( !DiskInsert( 0, str ) ) Error::SetError( Error::DiskMountFailed );
		break;
		
	case 'D1ej':		// DISK1 ro
		DiskEject( 0 );
		break;
		
	case 'D2in':		// DISK2 }
		if( OSD_FileSelect( NULL, FD_Disk, str, cfg->GetDiskPath() ) )
		if( !DiskInsert( 1, str ) ) Error::SetError( Error::DiskMountFailed );
		break;
		
	case 'D2ej':		// DISK2 ro
		DiskEject( 1 );
		break;
		
	case 'Rins':		// gROM }
		if( OSD_FileSelect( NULL, FD_ExtRom, str, cfg->GetExtRomPath() ) ){
			// Zbg𔺂̂ŃbZ[W\
			OSD_Message( MSG_RESETI, MSG_RESETC, OSDM_OK | OSDM_ICONINFO );
			if( !ExtRomInsert( str ) ) Error::SetError( Error::ExtRomMountFailed );
			else                       Reset();
		}
		break;
		
	case 'Reje':		// gROM ro
		// Zbg𔺂̂ŃbZ[W\
		OSD_Message( MSG_RESETE, MSG_RESETC, OSDM_OK | OSDM_ICONINFO );
		ExtRomEject();
		Reset();
		break;
		
	case 'Conf':		// ݒ
//		if ( ShowConfig( nibRef, cGlobal::IniPath ) )
		if ( ShowConfig( nibRef ,"") >0)
			// ċN?
			if( OSD_Message( MSG_RESTART, MSG_RESTARTC, OSDM_YESNO | OSDM_ICONQUESTION ) == OSDR_YES )
				SENDEVENT( SDL_RESTART )
		break;
		
	case 'Rset':		// Zbg
		Reset();
		break;
		
	case 'Rest':		// ċN
		SENDEVENT( SDL_RESTART )
		break;
		
	case 'Dsav':		// ǂłSAVE
		printf("DOKOSAVE\n"); fflush(stdout);
		if( OSD_FileSelect( NULL, FD_DokoSave, str, (char *)OSD_GetModulePath() ) ) ;
		if( !DokoDemoSave( str ) ) Error::SetError( Error::DokoWriteFailed );
		break;
		
	case 'Dlod':		// ǂłLOAD
		if( OSD_FileSelect( NULL, FD_DokoLoad, str, (char *)OSD_GetModulePath() ) )
		if( !DokoDemoLoad( str ) ) Error::SetError( Error::DokoReadFailed );
		break;

	case 'Rsav': 		// vCۑ@@Ver.1.10     Windy 2008/8/31
		if( REPLAY::GetStatus() == REP_IDLE ){
			if( OSD_FileSelect( NULL, FD_RepSave, str, (char * )OSD_GetModulePath() ) ){
				if( DokoDemoSave( str ) ) REPLAY::StartRecord( str );
			}
		}else if( REPLAY::GetStatus() == REP_RECORD ){
			REPLAY::StopRecord();
		}
		break;
		
	case 'Rply':		// vCĐ     Ver.1.10   Windy 2008/8/31
		if( REPLAY::GetStatus() == REP_IDLE ){
			if( OSD_FileSelect( NULL, FD_RepLoad, str, (char *)OSD_GetModulePath() ) ){
				if( DokoDemoLoad( str ) )
					REPLAY::StartReplay( str );
				else
					if( Error::GetError() == Error::DokoDiffModel ) Error::SetError( Error::ReplayDiffModel );
			}
		}else if( REPLAY::GetStatus() == REP_REPLAY ){
			REPLAY::StopReplay();
		}
		break;

	case 'Avic':		// rfILv`       Ver.1.08  Windy 2006/1/2
		if( !IsAVI() ){
			if( OSD_FileSelect( NULL, FD_AVISave, str, (char *)OSD_GetModulePath() ) ){
				AVI6::StartAVI( str, graph->ScreenX(), graph->ScreenY(), FRAMERATE, cfg->GetSampleRate(), cfg->GetScrBpp(), cfg->GetAviRle() );
			}
		}else{
			AVI6::StopAVI();
		}
		break;


	case 'Atyp':		// Auto Type
		if( OSD_FileSelect( NULL, FD_LoadAll, str, (char *)OSD_GetModulePath() ) )
		if( !AutoType( str ) ) Error::SetError( Error::Unknown );
		break;

		
	case 'Quit':		// I
		SENDEVENT( SDL_QUIT )
		break;
		
	case 'Nowt':		// WaitLύX
		sche->SetWaitEnable( sche->GetWaitEnable() ? FALSE : TRUE );
		break;
		
	case 'Tbtp':		// Turbo TAPE
		cfg->SetTurboTAPE( cfg->GetTurboTAPE() ? FALSE : TRUE );
		break;
	
	case 'Bstp':			// Boost Up    Ver.1.08  2006/1/1
	    cfg->SetBoostUp( cfg->GetBoostUp() ? FALSE : TRUE);    // add Ver.1.12 2008/8/31
		cmt->SetBoost( cmt->IsBoostUp() ? FALSE : TRUE );
		break;

	case 'Slin':		// XLC[hύX
		// rfILv`͖
		if( !AVI6::IsAVI() ) cfg->SetScanLine( cfg->GetScanLine() ? FALSE : TRUE );
		graph->ResizeScreen();	// XN[TCYύX
		break;

	case 'Ntsc':			// 4:3\ύX
		// rfILv`͖
		//printf("NTSC ");
		if( !AVI6::IsAVI() ){
			cfg->SetDispNTSC( cfg->GetDispNTSC() ? FALSE : TRUE );
			graph->ResizeScreen();	// XN[TCYύX
		}
		break;
		
	case 'Stbr':		// Xe[^Xo[\ԕύX
		cfg->SetStatDisp( cfg->GetStatDisp() ? FALSE : TRUE );
		graph->ResizeScreen();	// XN[TCYύX
		break;
		
						// MODE4J[
	case 'M4mn':		// mN
		cfg->SetMode4Color( 0 );
		vdg->SetMode4Color( 0 );
		break;
	case 'M4rb':		// /
		cfg->SetMode4Color( 1 );
		vdg->SetMode4Color( 1 );
		break;
	case 'M4br':		// /
		cfg->SetMode4Color( 2 );
		vdg->SetMode4Color( 2 );
		break;
	case 'M4pg':		// sN/
		cfg->SetMode4Color( 3 );
		vdg->SetMode4Color( 3 );
		break;
	case 'M4gp':		// /sN
		cfg->SetMode4Color( 4 );
		vdg->SetMode4Color( 4 );
		break;
							// t[XLbv    Ver.1.08  Windy 2006/1/2
	case 'fsk0':		// 0
		if( !AVI6::IsAVI() )  cfg->SetFrameSkip( 0 );
		break;
	case 'fsk1':		// 1
		if( !AVI6::IsAVI() )  cfg->SetFrameSkip( 1 );
		break;
	case 'fsk2':		// 2
		if( !AVI6::IsAVI() )  cfg->SetFrameSkip( 2 );
		break;
	case 'fsk3':		// 3
		if( !AVI6::IsAVI() )  cfg->SetFrameSkip( 3 );
		break;
	case 'fsk4':		// 4
		if( !AVI6::IsAVI() )  cfg->SetFrameSkip( 4 );
		break;
	case 'fsk5':		// 5
		if( !AVI6::IsAVI() )  cfg->SetFrameSkip( 5 );
		break;
		
	#ifdef USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	case 'Mmod':		// j^[[h
		ToggleMonitor();
		break;
		
	case 'Ptim':		// ^C}݋
		cfg->SetTimerIntr( cfg->GetTimerIntr() ? FALSE : TRUE );
		break;
	#endif			// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	
	case 'Vers':		// o[W
		{
		//ShowAbout( nibRef, cGlobal::IniPath );
		ShowAbout( nibRef, "" );
		break;
		}

	}
	
PopupMenuError:
	// j[
	DisposeMenu( menu );
CreateMenuError:
	// |bvAbvj[̃CxgnhACXg[
	RemoveEventHandler( popupHandler );
PopupInstallError:	
	DisposeEventHandlerUPP( popupUPP );	
	// Nib 
	DisposeNibReference( nibRef );
CreateNibError:	;
}




// Rg[ C ݒ
void SetControlStr( ControlRef control, char* str )
{
	CFStringRef cfstr;

	cfstr = CFStringCreateWithCString( NULL, str,	// SJIS ϊ
		kCFStringEncodingShiftJIS_X0213_00 );
	SetControlData( control, kControlEntireControl, kControlStaticTextCFStringTag,
		sizeof( CFStringRef ), &cfstr );
	CFRelease( cfstr );
}

// ݒǍށiSy[Wj
static bool OsdReadINI( WindowRef confWin, char*inipath )
{
	int st;					// Ԏ擾p
	BOOL yn;				// Ԏ擾p
	char str[PATH_MAX];		// 擾p

	ControlRef control;
	ControlID controlID;

	if( !ecfg ) return false;
	
/*
	if ( Ini ) delete Ini;

	// INIt@CJ
	try {
		Ini = new cIni();
		if ( !Ini->Init( inipath ) ) throw Error::IniReadFailed;
		cGlobal::InitIni( Ini, FALSE );
	}
	// new Ɏsꍇ
	catch ( std::bad_alloc ) {
		return false;
	}
	// O
	catch ( Error::Errno i ) {
		delete Ini;
		return false;
	}	
*/

	// {
	
	// @
	controlID.signature = APP_SIGNATURE;
	controlID.id = MACHINE_ID;
	GetControlByID( confWin, &controlID, &control );		// Rg[𓾂
//	Ini->GetInt( "CONFIG", "Model", &st, DEFAULT_MODEL );
	st = ecfg->GetModel();
	switch (st) {
		case 60: SetControlValue( control, 1 ); break;
		case 62: SetControlValue( control, 2 ); break;
		case 66: SetControlValue( control, 3 ); break;
		case 64: SetControlValue( control, 4 ); break;
		case 68: SetControlValue( control, 5 ); break;
	}

	// FDD
	controlID.id = FDD_NUM_ID;
	GetControlByID( confWin, &controlID, &control );
//	Ini->GetInt( "CONFIG", "FDD", &st, DEFAULT_FDD );
	st = ecfg->GetFddNum();
	SetControlValue( control, st+1 );

	// gRAM
	controlID.id = USE_EXT_RAM_ID;
	GetControlByID( confWin, &controlID, &control );
//	Ini->GetTruth( "CONFIG", "ExtRam", &st, DEFAULT_EXTRAM );
	yn = ecfg->GetUseExtRam();
	SetControlValue( control, yn );


	// m̃J[gbWgp
	controlID.id = USE_SOL_CAT_ID;
	GetControlByID( confWin, &controlID, &control );
//	Ini->GetTruth( "CONFIG", "ExtRam", &st, DEFAULT_EXTRAM );
	yn = ecfg->GetUseSoldier();
	SetControlValue( control, yn );

     // J[[h       Ver.1.09 by Windy
	controlID.id = SCR_BPP_ID;
 	GetControlByID( confWin, &controlID ,&control);
//	Ini->GetInt( "DISPLAY", "ScrBpp", &st, 8 );
	st = ecfg->GetScrBpp();
	//printf("read  st=%d \n",st);
    switch( st) 
        {
        case 8: st=0; break;
        case 16: st=1; break;
        case 24: st=2; break;
        }
 	SetControlValue( control,st+1);
	
	// [hSJ[
	controlID.id = MODE4_COL_ID;
	GetControlByID( confWin, &controlID, &control );
//	Ini->GetInt( "DISPLAY", "Mode4Color", &st, DEFAULT_MODE4_COLOR );
	st = ecfg->GetMode4Color();
	SetControlValue( control, st+1 );

	// XLC\
	controlID.id = DISP_SCAN_ID;
	GetControlByID( confWin, &controlID, &control );
//	Ini->GetTruth( "DISPLAY", "ScanLine", &st, DEFAULT_SCANLINE );
	yn = ecfg->GetScanLine();
	SetControlValue( control, yn );

	// XLCPx
	controlID.id = SCAN_LEVEL_ID;
	GetControlByID( confWin, &controlID, &control );
//	Ini->GetInt( "DISPLAY", "ScanLineBr", &st, DEFAULT_SCANLINEBR );
	st = ecfg->GetScanLineBr();
	sprintf( str, "%d", st );
	SetControlStr( control, str );

	// 4:3\    Ver.1.09   Windy
	controlID.id = DISP_NTSC_ID;
	GetControlByID( confWin, &controlID, &control );
//	Ini->GetTruth( "DISPLAY", "DispNTSC", &st, DEFAULT_DISPNTSC );
	yn = ecfg->GetDispNTSC();
	SetControlValue( control, yn );


	// tXN[
	controlID.id = FULLSCREEN_ID;
	GetControlByID( confWin, &controlID, &control );
	yn = ecfg->GetFullScreen();
	SetControlValue( control, yn );

	// Xe[^Xo[\
	controlID.id = DISP_STATUS_ID;
	GetControlByID( confWin, &controlID, &control );
	yn = ecfg->GetStatDisp();
	SetControlValue( control, yn );

    
	// t[XLbv
	controlID.id = FRAME_SKIP_ID;
	GetControlByID( confWin, &controlID, &control );
//	Ini->GetInt( "DISPLAY", "FrameSkip", &st, DEFAULT_FRAMESKIP ); // Ver.1.08  by windy 2006/1/9
	st = ecfg->GetFrameSkip();
	SetControlValue( control, st);
	


	// TvO[g
	controlID.id = SAMPLE_RATE_ID;
	GetControlByID( confWin, &controlID, &control );
//	Ini->GetInt( "SOUND", "SampleRate", &st, DEFAULT_SAMPLE_RATE );
	st = ecfg->GetSampleRate();
	switch ( st ) {
		case 44100: SetControlValue( control, 1 ); break;
		case 22050: SetControlValue( control, 2 ); break;
		case 11025: SetControlValue( control, 3 ); break;
	}

	// obt@TCY
	controlID.id = BUFF_SIZE_ID;
	GetControlByID( confWin, &controlID, &control );
//	Ini->GetInt( "SOUND", "SoundBuffer", &st, SOUND_BUFFER_SIZE );
	st = ecfg->GetSoundBuffer();
//	sprintf( str, "%d", st );
//	SetControlStr( control, str );
    SetControlValue( control, st);
	printf("buffsize '%s' %d \n",str,st);

	// PSG LPFJbgItg
	controlID.id = CUT_LPF_ID;
	GetControlByID( confWin, &controlID, &control );
	st = ecfg->GetPsgLPF();
	sprintf( str, "%d", st );
	SetControlStr( control, str );
//	printf("cut lpf read'%s' %d \n",str,st);

	// }X^[
	controlID.id = MASTER_VOL_ID;
	GetControlByID( confWin, &controlID, &control );
//	Ini->GetInt( "SOUND", "MasterVolume", &st, DEFAULT_MASTERVOL );
	st = ecfg->GetMasterVol();
	SetControlValue( control, st );

	// PSG
	controlID.id = PSG_VOL_ID;
	GetControlByID( confWin, &controlID, &control );
//	Ini->GetInt( "SOUND", "PsgVolume", &st, DEFAULT_PSGVOL );
	st = ecfg->GetPsgVol();
	SetControlValue( control, st );
		
	// 
	controlID.id = VOICE_VOL_ID;
	GetControlByID( confWin, &controlID, &control );
//	Ini->GetInt( "SOUND", "VoiceVolume", &st, DEFAULT_VOICEVOL );
	st = ecfg->GetVoiceVol();
	SetControlValue( control, st );
		
	// TAPEj^
	controlID.id = TAPE_MON_VOL_ID;
	GetControlByID( confWin, &controlID, &control );
//	Ini->GetInt( "SOUND", "TapeVolume", &st, DEFAULT_TAPEVOL );
	st = ecfg->GetCmtVol();
	SetControlValue( control, st );


	// L[s[gԊu
	controlID.id = KEY_REP_ID;
	GetControlByID( confWin, &controlID, &control );
//	Ini->GetInt( "CONFIG", "KeyRepeat", &st, DEFAULT_REPEAT );
	st = ecfg->GetKeyRepeat();
	sprintf( str, "%d", st );
	SetControlStr( control, str );



	// ROMpX
	controlID.id = ROM_FO_ID;
	GetControlByID( confWin, &controlID, &control );
//	sprintf( str, "%s" ROM_DIR, OSD_GetModulePath() );		// ftHg
//	Ini->GetString( "PATH", "RomPath", str, str );
	strncpy( str, ecfg->GetRomPath(), PATH_MAX );
	DelDelimiter( str );
	UnDelimiter( str );
	SetControlStr( control, str );
		
	// TAPEpX
	controlID.id = TAPE_FO_ID;
	GetControlByID( confWin, &controlID, &control );
//	sprintf( str, "%s" TAPE_DIR, OSD_GetModulePath() );		// ftHg
//	Ini->GetString( "PATH", "TapePath", str, str );
	strncpy( str, ecfg->GetTapePath(), PATH_MAX );
	DelDelimiter( str );
	UnDelimiter( str );
	SetControlStr( control, str );
	
	// DISKpX
	controlID.id = DISK_FO_ID;
	GetControlByID( confWin, &controlID, &control );
//	sprintf( str, "%s" DISK_DIR, OSD_GetModulePath() );		// ftHg
//	Ini->GetString( "PATH", "DiskPath", str, str );
	strncpy( str, ecfg->GetDiskPath(), PATH_MAX );
	DelDelimiter( str );
	UnDelimiter( str );
	SetControlStr( control, str );

	// gROMpX
	controlID.id = EXT_ROM_FO_ID;
	GetControlByID( confWin, &controlID, &control );
//	sprintf( str, "%s" EXTROM_DIR, OSD_GetModulePath() );	// ftHg
//	Ini->GetString( "PATH", "ExtRomPath", str, str );
	strncpy( str, ecfg->GetExtRomPath(), PATH_MAX );
	DelDelimiter( str );
	UnDelimiter( str );
	SetControlStr( control, str );

	// IMGpX
	controlID.id = SNAP_FO_ID;
	GetControlByID( confWin, &controlID, &control );
//	sprintf( str, "%s" IMAGE_DIR, OSD_GetModulePath() );	// ftHg
//	Ini->GetString( "PATH", "ImgPath", str, str );
	strncpy( str, ecfg->GetImgPath(), PATH_MAX );
	DelDelimiter( str );
	UnDelimiter( str );
	SetControlStr( control, str );

	// WAVEpX
	controlID.id = WAVE_FO_ID;
	GetControlByID( confWin, &controlID, &control );
//	sprintf( str, "%s" WAVE_DIR, OSD_GetModulePath() );		// ftHg
//	Ini->GetString( "PATH", "WavePath", str, str );
	strncpy( str, ecfg->GetWavePath(), PATH_MAX );
	DelDelimiter( str );
	UnDelimiter( str );
	SetControlStr( control, str );

	// FONTpX
	controlID.id = FONT_FO_ID;
	GetControlByID( confWin, &controlID, &control );
//	sprintf( str, "%s" FONT_DIR, OSD_GetModulePath() );		// ftHg
//	Ini->GetString( "PATH", "FontPath", str, str );
	strncpy( str, ecfg->GetFontPath(), PATH_MAX );
	DelDelimiter( str );
	UnDelimiter( str );
	SetControlStr( control, str );



		
	// gROMt@C
	controlID.id = EXT_ROM_FI_ID;
	GetControlByID( confWin, &controlID, &control );
//	Ini->GetString( "FILES", "ExtRom", str2, "" );
//	Delimiter( str2 );
//	if( str2[0] == '/' ) sprintf( str, "%s%s", cGlobal::GetRomPath(), str2 );
//	else                 strncpy( str, str2, PATH_MAX );
//	UnDelimiter( str );
	strncpy( str, ecfg->GetExtRomFile(), PATH_MAX );
	UnDelimiter( str );
	SetControlStr( control, str );
		
	// TAPE(LOAD)t@C
	controlID.id = TAPE_LOAD_FI_ID;
	GetControlByID( confWin, &controlID, &control );
//	Ini->GetString( "FILES", "tape", str, "" );
	strncpy( str, ecfg->GetTapeFile(), PATH_MAX );
	UnDelimiter( str );
	SetControlStr( control, str );
		
	// TAPE(SAVE)t@C
	controlID.id = TAPE_SAVE_FI_ID;
	GetControlByID( confWin, &controlID, &control );	
//	sprintf( str, "%s" SAVE_FILE, cGlobal::GetTapePath() );		// ftHg
//	Ini->GetString( "FILES", "save", str, str );
	strncpy( str, ecfg->GetSaveFile(), PATH_MAX );
	UnDelimiter( str );
	SetControlStr( control, str );	

	// DISKt@C
	controlID.id = DISK_FI_ID;
	GetControlByID( confWin, &controlID, &control );
//	Ini->GetString( "FILES", "disk", str, "" );
	strncpy( str, ecfg->GetDiskFile(), PATH_MAX );
	UnDelimiter( str );
	SetControlStr( control, str );

	// v^t@C	
	controlID.id = PRINTER_FI_ID;
	GetControlByID( confWin, &controlID, &control );
//	sprintf( str, "%s" PRINTER_FILE, OSD_GetModulePath() );		// ftHg
//	Ini->GetString( "FILES", "printer", str, str );
	strncpy( str, ecfg->GetPrinterFile(), PATH_MAX );
	UnDelimiter( str );
	SetControlStr( control, str );
		
	// SptHgt@C
	controlID.id = Z_FONT_FI_ID;
	GetControlByID( confWin, &controlID, &control );
//	sprintf( str, "%s" FONTZ_FILE, cGlobal::GetFontPath() );	// ftHg
//	Ini->GetString( "FILES", "fontz", str, str );
	strncpy( str, ecfg->GetFontFileZ(), PATH_MAX );
	UnDelimiter( str );
	SetControlStr( control, str );
		
	// ptHgt@C
	controlID.id = H_FONT_FI_ID;
	GetControlByID( confWin, &controlID, &control );
//	sprintf( str, "%s" FONTH_FILE, cGlobal::GetFontPath() );	// ftHg
//	Ini->GetString( "FILES", "fonth", str, str );
	strncpy( str, ecfg->GetFontFileH(), PATH_MAX );
	UnDelimiter( str );
	SetControlStr( control, str );



	// I[o[NbN
	controlID.id = OVERCLOCK_ID;
	GetControlByID( confWin, &controlID, &control );
//	Ini->GetInt( "CONFIG", "OverClock", &st, DEFAULT_REPEAT );
//	st = min( max( 1, st ), 1000 );
	st = min( max( 1, ecfg->GetOverClock() ), 1000 );
	sprintf( str, "%d", st );
	SetControlStr( control, str );

	// CRC`FbN
	controlID.id = CRC_CHECK_ID;
	GetControlByID( confWin, &controlID, &control );
//	Ini->GetTruth( "CONFIG", "CheckCRC", &st, TRUE );
	yn = ecfg->GetCheckCRC();
	SetControlValue( control, yn );

	// ROMpb`                  Ver.1.11  Windy
	controlID.id = PATCH_ROM_ID;
	GetControlByID( confWin, &controlID, &control );
	yn = ecfg->GetRomPatch();
	SetControlValue( control, yn );


	// Turbo TAPE
	controlID.id = TURBO_TAPE_ID;
	GetControlByID( confWin, &controlID, &control );
//	Ini->GetTruth( "CONFIG", "TurboTAPE", &st, DEFAULT_TURBO );
	yn = ecfg->GetTurboTAPE();
	SetControlValue( control, yn );

	// Boost Up
	controlID.id = BOOSTUP_ID;
	GetControlByID( confWin, &controlID, &control );
//	Ini->GetTruth( "CONFIG", "BoostUp", &st, DEFAULT_BOOST );
	yn = ecfg->GetBoostUp();
	SetControlValue( control, yn );
		
	// BoostUp ő{(N60[h)
	controlID.id = MAXBOOST60_ID;
	GetControlByID( confWin, &controlID, &control );
//	Ini->GetInt( "CONFIG", "MaxBoost60", &st, DEFAULT_MAXBOOST60 );
//	st = min( max( 1, st ), 100 );
	st = min( max( 1, ecfg->GetMaxBoost1() ), 100 );
	sprintf( str, "%d", st );
	SetControlStr( control, str );
		
	// BoostUp ő{(N60m/N66[h)
	//	Ini->GetInt( "CONFIG", "MaxBoost62", &st, DEFAULT_MAXBOOST62 );
	//	st = min( max( 1, st ), 100 );
	//	sprintf( str, "%d", st );
	//	SetDlgItemText( hwnd, ID_BOOST62, str );
	controlID.id = MAXBOOST62_ID;
	GetControlByID( confWin, &controlID, &control );
//	Ini->GetInt( "CONFIG", "MaxBoost62", &st, DEFAULT_MAXBOOST62 );
	st = min( max( 1, ecfg->GetMaxBoost2() ), 100 );
	sprintf( str, "%d", st );
	SetControlStr( control, str );

		
	// rfILv` RLE
	controlID.id = AVIRLE_ID;
	GetControlByID( confWin, &controlID, &control );
//	Ini->GetTruth( "MOVIE", "AviRle", &st, TRUE );
	yn = ecfg->GetAviRle();
	SetControlValue( control, yn );

	// I mF      Ver.1.09  Windy
	controlID.id = CHK_QUIT_ID;
	GetControlByID( confWin, &controlID, &control );
//	Ini->GetTruth( "CHECK", "CkQuit", &st, FALSE );
	yn = ecfg->GetCkQuit();
	SetControlValue( control, yn );

	// I INIt@Cۑ     Ver.1.11  Windy 
	controlID.id = SAVE_INI_ID;
	GetControlByID( confWin, &controlID, &control );
	yn = ecfg->GetSaveQuit();
    SetControlValue( control ,yn );
    
	return true;
}

// Rg[ C 𓾂
void GetControlStr( ControlRef control, char* str )
{
	CFStringRef cfstr;
	Size size;
	GetControlData( control, kControlEditTextPart, kControlStaticTextCFStringTag,
		sizeof( CFStringRef ), &cfstr , &size);
	CFStringGetCString( cfstr, str, PATH_MAX,	// SJIS ɕϊ
		kCFStringEncodingShiftJIS_X0213_00 );
}

// ݒށiSy[Wj
static bool OsdWriteINI( WindowRef confWin )
{
	ControlRef control;
	ControlID controlID;
	int st;
	int yn;
	char str[PATH_MAX];

//	if (!Ini) return false;
    if( !ecfg) return false;

	controlID.signature = APP_SIGNATURE;
	// {

	// @
	controlID.id = MACHINE_ID;
	GetControlByID( confWin, &controlID, &control );
	int machineMap[6] = {0, 60, 62, 66, 64, 68 };
	st = machineMap[GetControlValue( control )];
//  Ini->PutEntry( "CONFIG", MSINI_Model, "Model", "%02d", st );
	ecfg->SetModel( st );
		
	// FDD
	controlID.id = FDD_NUM_ID;
	GetControlByID( confWin, &controlID, &control );
	st = GetControlValue( control ) - 1;
//  Ini->PutEntry( "CONFIG", MSINI_FDD, "FDD", "%d", st );
	ecfg->SetFddNum( st );


	// gRAM
	controlID.id = USE_EXT_RAM_ID;
	GetControlByID( confWin, &controlID, &control );
	st = GetControlValue( control );
//	Ini->PutEntry( "CONFIG", MSINI_ExtRam, "ExtRam", "%s", st ? "Yes" : "No" );
	ecfg->SetUseExtRam( st );
		
	// m̃J[gbWgp       Ver.1.11
	controlID.id = USE_SOL_CAT_ID;
	GetControlByID( confWin, &controlID, &control );
	yn = GetControlValue( control );
	ecfg->SetUseSoldier( yn );

	
	// J[[h      Ver.1.09  Windy
	controlID.id = SCR_BPP_ID;
	GetControlByID( confWin, &controlID, &control );
	st = GetControlValue( control )-1 ;
	//printf("write  st=%d \n",st);
    switch( st)
	   {
	   case 0: st=8; break;
	   case 1: st=16; break;
	   case 2: st=24; break;
	   }
//	Ini->PutEntry( "DISPLAY", MSINI_ScrBpp, "ScrBpp", "%d", st );
	ecfg->SetScrBpp( st );

	
	// [hSJ[
	controlID.id = MODE4_COL_ID;
	GetControlByID( confWin, &controlID, &control );
	st = GetControlValue( control ) - 1;		
//	Ini->PutEntry( "DISPLAY", MSINI_Mode4Color, "Mode4Color", "%d", st );
	ecfg->SetMode4Color( st );

	// XLC
	controlID.id = DISP_SCAN_ID;
	GetControlByID( confWin, &controlID, &control );
	st = GetControlValue( control );	
//	Ini->PutEntry( "DISPLAY", MSINI_ScanLine, "ScanLine", "%s", st ? "Yes" : "No" );
	ecfg->SetScanLine( st );
	
	// XLCPx
	controlID.id = SCAN_LEVEL_ID;
	GetControlByID( confWin, &controlID, &control );
	GetControlStr( control, str );
	st = strtol( str, NULL, 0 );
//	Ini->PutEntry( "DISPLAY", MSINI_ScanLineBr, "ScanLineBr", "%d", st );
	ecfg->SetScanLineBr( st );

	// 4:3\    Ver.1.09   Windy
	controlID.id = DISP_NTSC_ID;
    GetControlByID( confWin, &controlID, &control );
	st = GetControlValue( control );	
//  Ini->PutEntry( "DISPLAY", MSINI_DispNTSC, "DispNTSC", "%s",st  ? "Yes" : "No" );
	ecfg->SetDispNTSC( st );


	// tXN[    Ver.1.11
	controlID.id = FULLSCREEN_ID;
    GetControlByID( confWin, &controlID, &control );
	yn = GetControlValue( control );	
	ecfg->SetFullScreen( yn);
	
	// Xe[^Xo[\   Ver.1.11
	controlID.id = DISP_STATUS_ID;
    GetControlByID( confWin, &controlID, &control );
	yn = GetControlValue( control );	
	ecfg->SetStatDisp( yn );


	// t[XLbv
	controlID.id = FRAME_SKIP_ID;
	GetControlByID( confWin, &controlID, &control );
	st = GetControlValue( control );		
//	Ini->PutEntry( "DISPLAY", MSINI_FrameSkip, "FrameSkip", "%d", st ); // Ver.1.08 by Windy  2006/1/9
	ecfg->SetFrameSkip( st );


	// TvO[g
	controlID.id = SAMPLE_RATE_ID;
	GetControlByID( confWin, &controlID, &control );
	int sampleMap[6] = {0, 44100, 22050, 11025 };
	st = sampleMap[GetControlValue( control )];
//	Ini->PutEntry( "SOUND", MSINI_SampleRate, "SampleRate", "%d", st );
	ecfg->SetSampleRate( st );

	// obt@TCY
	controlID.id = BUFF_SIZE_ID;
	GetControlByID( confWin, &controlID, &control );
//	GetControlStr( control, str );
//	st = strtol( str, NULL, 0 );

    st = GetControlValue( control );
//	st = max( 1, min( st,10));             // El`FbN 2008/7/7 Windy 
//	Ini->PutEntry( "SOUND", MSINI_SoundBuffer, "SoundBuffer", "%d", st );
	ecfg->SetSoundBuffer( st );
//	printf("buffsize %d \n",st);

	// PSG LPFJbgItg    Ver.1.11
	controlID.id = CUT_LPF_ID;
	GetControlByID( confWin, &controlID, &control );
	GetControlStr( control, str );
	st = strtol( str, NULL, 0 );
	ecfg->SetPsgLPF( st );
//	printf("cut lpf write'%s' %d \n",str,st);

	// }X^[
	controlID.id = MASTER_VOL_ID;
	GetControlByID( confWin, &controlID, &control );
	st = GetControlValue( control );		
//	Ini->PutEntry( "SOUND", MSINI_MasterVolume, "MasterVolume", "%d", st );
	ecfg->SetMasterVol( st );
		
	// PSG
	controlID.id = PSG_VOL_ID;
	GetControlByID( confWin, &controlID, &control );
	st = GetControlValue( control );
//	Ini->PutEntry( "SOUND", MSINI_PsgVolume, "PsgVolume", "%d", st );
	ecfg->SetPsgVol( st );
		
	// 
	controlID.id = VOICE_VOL_ID;
	GetControlByID( confWin, &controlID, &control );
	st = GetControlValue( control );
//	Ini->PutEntry( "SOUND", MSINI_VoiceVolume, "VoiceVolume", "%d", st );
	ecfg->SetVoiceVol( st );
		
	// TAPEj^
	controlID.id = TAPE_MON_VOL_ID;
	GetControlByID( confWin, &controlID, &control );
	st = GetControlValue( control );	
//	Ini->PutEntry( "SOUND", MSINI_TapeVolume, "TapeVolume", "%d", st );
	ecfg->SetCmtVol( st );

	// L[s[gԊu
	controlID.id = KEY_REP_ID;
	GetControlByID( confWin, &controlID, &control );	
	GetControlStr( control, str );
	st = strtol( str, NULL, 0 );
//	Ini->PutEntry( "CONFIG", MSINI_KeyRepeat, "KeyRepeat", "%d", st );
	ecfg->SetKeyRepeat( st );


	// ROMpX
	controlID.id = ROM_FO_ID;
	GetControlByID( confWin, &controlID, &control );
	GetControlStr( control, str );
	//DelDelimiter( str );
	//UnDelimiter( str );
	//Ini->PutEntry( "PATH", MSINI_RomPath, "RomPath", "%s", str );
	ecfg->SetRomPath( str );
				
	// TAPEpX
	controlID.id = TAPE_FO_ID;
	GetControlByID( confWin, &controlID, &control );
	GetControlStr( control, str );
//  DelDelimiter( str );
//  UnDelimiter( str );
//  Ini->PutEntry( "PATH", MSINI_TapePath, "TapePath", "%s", str );
	ecfg->SetTapePath( str );
		
	// DISKpX
	controlID.id = DISK_FO_ID;
	GetControlByID( confWin, &controlID, &control );
	GetControlStr( control, str );
//	DelDelimiter( str );
//	UnDelimiter( str );
//	Ini->PutEntry( "PATH", MSINI_DiskPath, "DiskPath", "%s", str );
	ecfg->SetDiskPath( str );
		
	// gROMpX
	controlID.id = EXT_ROM_FO_ID;
	GetControlByID( confWin, &controlID, &control );
	GetControlStr( control, str );
//	DelDelimiter( str );
//	UnDelimiter( str );
//	Ini->PutEntry( "PATH", MSINI_ExtRomPath, "ExtRomPath", "%s", str );
	ecfg->SetExtRomPath( str );
		
	// IMGpX
	controlID.id = SNAP_FO_ID;
	GetControlByID( confWin, &controlID, &control );
	GetControlStr( control, str );
	DelDelimiter( str );
	UnDelimiter( str );
//	Ini->PutEntry( "PATH", MSINI_ImgPath, "ImgPath", "%s", str );
    ecfg->SetImgPath( str );
		
	// WAVEpX
	controlID.id = WAVE_FO_ID;
	GetControlByID( confWin, &controlID, &control );
	GetControlStr( control, str );
//	DelDelimiter( str );
//	UnDelimiter( str );
//	Ini->PutEntry( "PATH", MSINI_WavePath, "WavePath", "%s", str );
	ecfg->SetWavePath( str );
		
	// FONTpX
	controlID.id = FONT_FO_ID;
	GetControlByID( confWin, &controlID, &control );
	GetControlStr( control, str );
//	DelDelimiter( str );
//	UnDelimiter( str );
//	Ini->PutEntry( "PATH", MSINI_FontPath, "FontPath", "%s", str );
    ecfg->SetFontPath( str );




	// gROMt@C
	controlID.id = EXT_ROM_FI_ID;
	GetControlByID( confWin, &controlID, &control );
	GetControlStr( control, str );
//	UnDelimiter( str );
//	Ini->PutEntry( "FILES", MSINI_ExtRom, "ExtRom", "%s", str );
	ecfg->SetExtRomFile( str );
		
	// TAPE(LOAD)t@C
	controlID.id = TAPE_LOAD_FI_ID;
	GetControlByID( confWin, &controlID, &control );
	GetControlStr( control, str );
//	UnDelimiter( str );
//	Ini->PutEntry( "FILES", MSINI_tape, "tape", "%s", str );
	ecfg->SetTapeFile( str );
		
	// TAPE(SAVE)t@C
	controlID.id = TAPE_SAVE_FI_ID;
	GetControlByID( confWin, &controlID, &control );
	GetControlStr( control, str );
//	UnDelimiter( str );
//	Ini->PutEntry( "FILES", MSINI_save, "save", "%s", str );
	ecfg->SetSaveFile( str );
		
	// DISKt@C
	controlID.id = DISK_FI_ID;
	GetControlByID( confWin, &controlID, &control );
	GetControlStr( control, str );
//	UnDelimiter( str );
//	Ini->PutEntry( "FILES", MSINI_disk, "disk", "%s", str );
	ecfg->SetDiskFile( str );
		
	// v^t@C
	controlID.id = PRINTER_FI_ID;
	GetControlByID( confWin, &controlID, &control );
	GetControlStr( control, str );
//	UnDelimiter( str );
//	Ini->PutEntry( "FILES", MSINI_printer, "printer", "%s", str );
	ecfg->SetPrinterFile( str );
		
	// SptHgt@C
	controlID.id = Z_FONT_FI_ID;
	GetControlByID( confWin, &controlID, &control );
	GetControlStr( control, str );
//	UnDelimiter( str );
//	Ini->PutEntry( "FILES", MSINI_fontz, "fontz", "%s", str );
	ecfg->SetFontFileZ( str );
		
	// ptHgt@C
	controlID.id = H_FONT_FI_ID;
	GetControlByID( confWin, &controlID, &control );
	GetControlStr( control, str );
//	UnDelimiter( str );
//	Ini->PutEntry( "FILES", MSINI_fonth, "fonth", "%s", str );
	ecfg->SetFontFileH( str );

	// I[o[NbN
	controlID.id = OVERCLOCK_ID;
	GetControlByID( confWin, &controlID, &control );
	GetControlStr( control, str );
	st = min( max( 1, strtol( str, NULL, 0 ) ), 1000 );
//	Ini->PutEntry( "CONFIG", MSINI_OverClock, "OverClock", "%d", st );
	ecfg->SetOverClock( st );

	// CRC`FbN
	controlID.id = CRC_CHECK_ID;
	GetControlByID( confWin, &controlID, &control );
	yn = GetControlValue( control );
//	Ini->PutEntry( "CONFIG", MSINI_CheckCRC, "CheckCRC", "%s", st ? "Yes" : "No" );	
	ecfg->SetCheckCRC( yn );

	// ROMpb`       Ver.1.11
	controlID.id = PATCH_ROM_ID;
	GetControlByID( confWin, &controlID, &control );
	yn = GetControlValue( control );
	ecfg->SetRomPatch( yn );


	// Turbo TAPE
	controlID.id = TURBO_TAPE_ID;
	GetControlByID( confWin, &controlID, &control );
	yn = GetControlValue( control );
//	Ini->PutEntry( "CONFIG", MSINI_TurboTAPE, "TurboTAPE", st ? "Yes" : "No" );
	ecfg->SetTurboTAPE( yn );

	// Boost Up
	//Ini->PutEntry( "CONFIG", MSINI_BoostUp, "BoostUp", "%s", IsDlgButtonChecked( hwnd, ID_CB5 ) ? "Yes" : "No" );
	controlID.id = BOOSTUP_ID;
	GetControlByID( confWin, &controlID, &control );
	st = GetControlValue( control );
//	Ini->PutEntry( "CONFIG", MSINI_BoostUp, "BoostUp", "%s", st ? "Yes" : "No" );	
	ecfg->SetBoostUp( st );
		
	// BoostUp ő{(N60[h)
	controlID.id = MAXBOOST60_ID;
	GetControlByID( confWin, &controlID, &control );
	GetControlStr( control, str );
	st = min( max( 1, strtol( str, NULL, 0 ) ), 100 );
//	Ini->PutEntry( "CONFIG", MSINI_MaxBoost60, "MaxBoost60", "%d", st );
	ecfg->SetMaxBoost1( st );

		
	// BoostUp ő{(N60m/N66[h)
	// BoostUp ő{(N60m/N66[h)
	controlID.id = MAXBOOST62_ID;
	GetControlByID( confWin, &controlID, &control );
	GetControlStr( control, str );
	st = min( max( 1, strtol( str, NULL, 0 ) ), 100 );
//	Ini->PutEntry( "CONFIG", MSINI_MaxBoost62, "MaxBoost62", "%d", st );
	ecfg->SetMaxBoost2( st );


	// rfILv` RLE
	controlID.id = AVIRLE_ID;
	GetControlByID( confWin, &controlID, &control );
	st = GetControlValue( control );
//	Ini->PutEntry( "MOVIE", MSINI_AviRle, "AviRle", "%s", st ? "Yes" : "No" );
	ecfg->SetAviRle( st );
		
	// I mF   Ver.1.09  Windy
	controlID.id = CHK_QUIT_ID;
	GetControlByID( confWin, &controlID, &control );
	st = GetControlValue( control );
//	Ini->PutEntry( "CHECK", MSINI_CkQuit, "CkQuit", "%s", st ? "Yes" : "No" );
	ecfg->SetCkQuit( st );
	
	// I INIt@Cۑ
	controlID.id = SAVE_INI_ID;
	GetControlByID( confWin, &controlID, &control );
	st = GetControlValue( control );
	ecfg->SetSaveQuit( st );

#if 0  // Ver.1.11 폜
	// INIt@Cɏ
	Ini->Write();
#endif
	return true;
//    return TRUE;
}

// yC ID ́A129 - 136
// Ver.1.09 ŁA127: ́@ǉB
static int tabList[] = { 9, 129, 130, 131, 127, 132, 133, 134, 135, 136 };
static int lastTabIndex = 1;

// ^ũyCؑւ֐Bu CarbonvQƁB
void SwitchItemOfTabControl( int currentTabIndex, ControlRef tabControl, WindowRef confWin )
{
	ControlRef userPane;
	ControlRef selectedPane = NULL;
	ControlID paneControlID;
	UInt16 i;

	lastTabIndex = currentTabIndex;
	paneControlID.signature = APP_SIGNATURE;
	for ( i=1; i < tabList[0]+1; i++ ) {
		paneControlID.id = tabList[i];
		GetControlByID (confWin, &paneControlID, &userPane);
		if (i == currentTabIndex)
			selectedPane = userPane;
		else
			SetControlVisibility( userPane, false, true );
	}
	if ( selectedPane ) {
		SetControlVisibility( selectedPane, true, true );
	}
			
	Draw1Control( tabControl );
}

// ^uؑւCxgnhBu CarbonvQƁB
pascal OSStatus TabEventHandler( EventHandlerCallRef inHandlerRef,
	EventRef inEvent, void *win )
{

	WindowRef confWin = (WindowRef)win;
	ControlRef tabControl;
	ControlID controlID;
	OSStatus result;
	controlID.signature = APP_SIGNATURE;
	controlID.id = TAB_ID;
	int currentTabIndex;
	
	GetControlByID( confWin, &controlID, &tabControl );
	currentTabIndex = GetControlValue( tabControl );
	
	if ( currentTabIndex == lastTabIndex ) {
		result =eventNotHandledErr;
	} else {
		SwitchItemOfTabControl( currentTabIndex, tabControl, confWin );
		result = noErr;
	}
	return result;
}	

// |bvAbvj[̃Cxgnh
static pascal OSStatus popupMenuEventHandler( EventHandlerCallRef inHandlerRef,
	EventRef inEvent, void *userData )
{
	OSStatus result = eventNotHandledErr;
	HICommand command;
	
	GetEventParameter( inEvent, kEventParamDirectObject, typeHICommand, NULL,
		sizeof( HICommand ), NULL, &command );
	switch ( command.commandID ) {
	  case 'Rset':	// Zbg
	  case 'Rest':	// ċN
	  case 'Dsav':	// ǂłSAVE
	  case 'Dlod':	// ǂłLOAD
	  case 'Rsav': // vCۑ   Ver.1.10  Windy 2008/3/31
	  case 'Rply': // vCĐ   Ver.1.10  Windy 2008/3/31
	  case 'Avic':  // rfILv`@@@Ver.1.08 Windy 2006/1/2
      case 'Atyp': // AUTO TYPE     Ver.1.09 Windy 2007/4/26
	  case 'Quit':	// I
	  case 'Tins':	// e[v}
	  case 'Teje':	// e[vo
	  case 'D1in':	// fBXN 1 }
	  case 'D1ej':	// fBXN 1 o
	  case 'Rins':	// fBXN 2 }
	  case 'Reje':	// fBXN 2 o
	  case 'Stbr':	// Xe[^Xo[
	  case 'Ntsc':  //  4:3 \          Ver.1.09 Windy 2007/4/26
	  case 'Slin':	// XLC
	  case 'M4mn':	// mN
	  case 'M4rb':	// /
	  case 'M4br':	// /
	  case 'M4pg':	// /
	  case 'M4gp':	// /
	  case 'fsk0':  // t[XLbv  OF UO    Ver.1.08  Windy 2006/1/1
	  case 'fsk1':  //               1F 3O
	  case 'fsk2':  //               2F 2O
	  case 'fsk3':  //               3F 15
	  case 'fsk4':  //               4F 12
	  case 'fsk5':  //			 5F 10
	  case 'Nowt':	// EFCg
	  case 'Tbtp':	// Turbo TAPE
	  case 'Bstp':  // Boost up		Ver.1.08  Windy  2006/1/1
	  case 'Conf':	// ݒ
	  case 'Mmod':	// j^[h
	  case 'Ptim':	// ^C}݋֎~
	  case 'Vers':	// o[W
		*(SInt32 *)userData = command.commandID;
		result = noErr;
		break;
	}
	return result;
}

// ݒ OK / Cancel {^Cxgnh
static pascal OSStatus ButtonEventHandler( EventHandlerCallRef inHandlerRef,
	EventRef inEvent, void *okButton )
{
	OSStatus result = eventNotHandledErr;
	HICommand command;
	
	GetEventParameter( inEvent, kEventParamDirectObject, typeHICommand, NULL,
		sizeof( HICommand ), NULL, &command );
	switch ( command.commandID ) {	
		case 'ok  ':	// OK {^
			*(bool *)okButton = true;
			QuitApplicationEventLoop(); // {^ꂽ_ŃCxg[v𔲂
			result = noErr;
			break;
		case 'not!':	// Cancel {^
			*(bool *)okButton = false;
			okButton = false;
			QuitApplicationEventLoop();	// 
			result = noErr;
			break;
	}
	return result;
}

// FύX{^̃Cxgnh
static pascal OSStatus ColorEventHandler( EventHandlerCallRef inHanderRef, 
	EventRef inEvent, void *colorNum)
{
	OSStatus result = eventNotHandledErr;
	HICommand command;
	CGrafPtr cptr;
	Rect bounds;
	int color = (int)colorNum;
	char strin[16], str[PATH_MAX];
	int st;
	static RGBColor rgb;
	ControlID controlID;
	ControlRef control;
	
	controlID.signature = APP_SIGNATURE;	
//	controlID.id = COLOR17_ID + color - 17;
	controlID.id = COLOR16_ID + color - 16;		// Ver.1.08  Windy 2006/1/9
	GetControlByID ( confWin, &controlID, &control );

	GetEventParameter( inEvent, kEventParamDirectObject, typeHICommand, NULL,
		sizeof( HICommand ), NULL, &command );
	
	switch ( GetEventKind(inEvent) ) {
		case kEventControlDraw: {	// I[i[h[
			sprintf( strin, "COL%03d", color );	
			if (Ini->GetString( "COLOR", strin, str, "" ) ) {
				st = strtol( str, NULL, 16 );
				GetEventParameter( inEvent, kEventParamGrafPort, typeGrafPtr,
					NULL, sizeof( CGrafPtr ), NULL, &cptr );
				// QuickDraw ŃRg[ɕ`
				GetControlBounds( control, &bounds );
				rgb.red = ((st>>16) & 0xff) << 8;
				rgb.green = ((st>>8) & 0xff) << 8;
				rgb.blue = (st & 0xff) << 8;
				SetPort( cptr );
				RGBForeColor( &rgb );
				PenSize( 1, 1 );
				PaintRect( &bounds );
				QDFlushPortBuffer( cptr, NULL );
			}	
			result = noErr;
			break;
		}
		case kEventControlClick: {	// F̕ύX
			sprintf( strin, "COL%03d", color );
			if (Ini->GetString( "COLOR", strin, str, "" ) ) {
				NColorPickerInfo cpinfo;
				st = strtol( str, NULL, 16 );			
				cpinfo.theColor.profile = 0L;
				cpinfo.theColor.color.rgb.red = ((st>>16) & 0xff) << 8;
				cpinfo.theColor.color.rgb.green = ((st>>8) & 0xff) << 8;
				cpinfo.theColor.color.rgb.blue = (st & 0xff) << 8;	
				cpinfo.dstProfile = 0L;
				cpinfo.flags = kColorPickerCanModifyPalette |
					kColorPickerCanAnimatePalette;
				cpinfo.placeWhere = kCenterOnMainScreen;
				cpinfo.pickerType = 0L;
				cpinfo.eventProc = NULL;
				cpinfo.colorProc = NULL;
				cpinfo.colorProcData = NULL;
				cpinfo.prompt[0] = 0;

				if ((NPickColor(&cpinfo) == noErr) && (cpinfo.newColorChosen != 0)) {
					rgb.red = cpinfo.theColor.color.rgb.red;
					rgb.green = cpinfo.theColor.color.rgb.green;
					rgb.blue = cpinfo.theColor.color.rgb.blue;
					//Ini->PutEntry( "COLOR", OSD_ColorName( color-17 ), strin, "%02X%02X%02X", rgb.red>>8, rgb.green>>8, rgb.blue>>8 );
					Ini->PutEntry( "COLOR", OSD_ColorName( color-16 ), strin, "%02X%02X%02X", rgb.red>>8, rgb.green>>8, rgb.blue>>8 );		// Ver.1.08 Windy 2006/1/9
				}
				Draw1Control( control );
			}
			result = noErr;
			break;
		}
	}
	return result;
}

// ݒ			
bool ShowConfig( IBNibRef nibRef, char *initpath )
{
	int i;
	OSStatus err;
	bool okButton = false;	// OK {^ꂽǂ̃tO

	// Rg[pϐ
	ControlID controlID;
	ControlRef tabControl, colorControl;	
			
	// Cxgnh[pϐ
	EventHandlerUPP tabUPP, buttonUPP, colorUPP[48];
	EventHandlerRef tabEvent, buttonEvent, colorEvent[48];

	// INIt@CJ
	try{
		ecfg = new cConfig();
		if( !ecfg->Init() ) throw Error::IniReadFailed;
	}
	// new Ɏsꍇ
	catch( std::bad_alloc ){
		return -1;
	}
	// O
	catch( Error::Errno i ){
		delete ecfg;
		ecfg = NULL;
		return -1;
	}

	
	// uCarbonvł͂ꂪ~XvBBB
	EventTypeSpec tabControlSpec = {kEventClassControl, kEventControlHit };
	EventTypeSpec buttonControlSpec = { kEventClassCommand, kEventCommandProcess };
	EventTypeSpec colorControlSpec[] =
		{ { kEventClassControl, kEventControlClick },
		{ kEventClassControl, kEventControlDraw } };
	
	// ݒEBhE
	err = CreateWindowFromNib( nibRef, CFSTR( "Config" ), &confWin );
	require_noerr( err, CantDoConf );

	// ^uؑւCxgnh̃CXg[
	controlID.signature = APP_SIGNATURE;
	controlID.id = TAB_ID;
	GetControlByID ( confWin, &controlID, &tabControl );
	tabUPP = NewEventHandlerUPP( TabEventHandler );
	InstallControlEventHandler( tabControl, tabUPP, 1, &tabControlSpec,
		confWin, &tabEvent );

	// ŏ̃yCIĂ
	SwitchItemOfTabControl(1, tabControl, confWin );

	// OK / Cancel {^̃Cxgnh̃CXg[
	buttonUPP = NewEventHandlerUPP( ButtonEventHandler );
	InstallWindowEventHandler( confWin, buttonUPP, 1, &buttonControlSpec,
			&okButton, &buttonEvent ); 

	// FύX{^̃Cxgnh̃CXg[
	for ( i = 16; i <= 64; i++ ) {			// Ver.1.09  Windy 2006/1/9
		//controlID.id = COLOR17_ID + i - 16;
		controlID.id = COLOR16_ID + i - 16;
		GetControlByID ( confWin, &controlID, &colorControl );
		colorUPP[i-17] = NewEventHandlerUPP( ColorEventHandler );
		InstallControlEventHandler( colorControl, colorUPP[i-17], 2, colorControlSpec,
			(void *)i, &colorEvent[i-16] );
	}
	
	
	// ݒǂݍ
	if ( !OsdReadINI( confWin, initpath ) ) goto CantDoConf;

	// Z^O
	RepositionWindow( confWin, NULL, kWindowAlertPositionOnMainScreen );

	// ݒEBhE\
	ShowWindow ( confWin );

	// Cxg[v
	RunApplicationEventLoop();

	// ݒ菑
	if ( okButton ) {
		if ( !OsdWriteINI( confWin ) ) okButton = false;
	}
	// OK{^ꂽȂINIt@C
	if( okButton ) ecfg->Write();

	// ݒEBhE
	HideWindow( confWin );
	DisposeWindow( confWin );

	// CxgnhACXg[
	DisposeEventHandlerUPP( buttonUPP );
	DisposeEventHandlerUPP( tabUPP );
	RemoveEventHandler( tabEvent );
	RemoveEventHandler( buttonEvent );
	for (i=0; i<48; i++) {
		DisposeEventHandlerUPP( colorUPP[i] );
		RemoveEventHandler( colorEvent[i] );
	}
	
CantDoConf:
	return okButton;
}

// Resource fBNgɂ@PICTt@CEChEɕ`悵܂B
// window 
// x ,y   `ʒu
// pictFileName PICTt@C̃t@C
short drawPictFile( WindowRef window , int x, int y , char *pictFileName)
{
	short   ret=1;
	CGrafPtr	port;
	QDPictRef   pref;
	CFStringRef name;
	CGRect		crt;
	CGRect		crt2;
	CGContextRef	ctx;
	CFURLRef	url;
	
	name = CFStringCreateWithCString( NULL, pictFileName, kCFStringEncodingASCII );
	url  = CFBundleCopyResourceURL( CFBundleGetMainBundle(), name , NULL,NULL );
	if( pref= QDPictCreateWithURL( url ))
		{
		 port = GetWindowPort( window );
		 if( !CreateCGContextForPort( port, &ctx) )
			{
			 crt = QDPictGetBounds( pref );			// PICT 摜̋`𓾂
			 crt2 = CGRectMake( x , y , crt.size.width *2 , crt.size.height *2); // `ʒu
			 
			 QDPictDrawToCGContext( ctx, crt2, pref); // `s
			 CGContextFlush( ctx );
			 CGContextRelease( ctx );
			 ret = noErr;
			}
		QDPictRelease( pref );
		}
	return ret;
}

// o[W			
bool ShowAbout( IBNibRef nibRef, char *initpath )
{
	//int i;
	OSStatus err;
	bool okButton = false;	// OK {^ꂽǂ̃tO

	// Rg[pϐ
	//ControlID controlID;
	//ControlRef tabControl, colorControl;	
			
	// Cxgnh[pϐ
	EventHandlerUPP buttonUPP;
	EventHandlerRef buttonEvent;
	
	// uCarbonvł͂ꂪ~XvBBB
	EventTypeSpec buttonControlSpec = { kEventClassCommand, kEventCommandProcess };
	
	// ݒEBhE
	err = CreateWindowFromNib( nibRef, CFSTR( "About" ), &aboutWin );
	require_noerr( err, CantDoConf );

	// OK / Cancel {^̃Cxgnh̃CXg[
	buttonUPP = NewEventHandlerUPP( ButtonEventHandler );
	InstallWindowEventHandler( aboutWin, buttonUPP, 1, &buttonControlSpec,
			&okButton, &buttonEvent ); 

	// Z^O
	RepositionWindow( aboutWin, NULL, kWindowAlertPositionOnMainScreen );

	// ݒEBhE\
	ShowWindow ( aboutWin );
	
	// ACR̕`
	drawPictFile( aboutWin ,120,230, "pc6001.pct");

	// Cxg[v
	RunApplicationEventLoop();

	// ݒEBhE
	HideWindow( aboutWin );
	DisposeWindow( aboutWin );

	// CxgnhACXg[
	DisposeEventHandlerUPP( buttonUPP );
	RemoveEventHandler( buttonEvent );
	
CantDoConf:
	return okButton;
}






#endif
