// OSˑ̔ėp[`(UIp)
// ɍ킹ĕR[hύX邱
//  Windows : ShiftJIS
//  Unix    : EUC

#ifdef WIN32
#include <windows.h>
#include <shlobj.h>
#endif

#include <string.h>
#include <unistd.h>

//#include "SDL_syswm.h"

#include "osd.h"
#include "common.h"
#include "p6v.h"

#ifdef __APPLE__
#include <Carbon/Carbon.h>
#define APP_SIGNATURE 		'P60V'	// Ƃ肠AvP[VVOl` P60V
//#define OK_TEXT				1		// bZ[W_CAÕRg[ ID
//#define OK_CANCEL_TEXT		2
//#define YES_NO_TEXT			3
//#define YES_NO_CANCEL_TEXT	4

////////////////////////////////////////////////////////////////
// R[h`ϊ(UTF8 -> SJIS & SJIS -> UTF8)
////////////////////////////////////////////////////////////////
char* OSD_UTF8toSJIS( const char *src );
char* OSD_SJIStoUTF8( const char *src );
#endif

//#ifdef WIN32
///////////////////////////////////////////////////////////
// [J֐`
///////////////////////////////////////////////////////////
//static BOOL CALLBACK OsdBrowseCallbackProc( HWND, UINT, LPARAM, LPARAM ); // OSD_FolderDiaog()ŎgpR[obNvV[W

///////////////////////////////////////////////////////////
// dȂɃO[oϐ
///////////////////////////////////////////////////////////
//static HANDLE hMutex;			// dN`FbNp̃~[ebNX
//static BROWSEINFO OBI;			// OSD_FolderDiaog()Ŏgpi[\
//#endif

///////////////////////////////////////////////////////////
// bZ[Wz
///////////////////////////////////////////////////////////
// ʃbZ[W
const char *MsgStr[] = {
	"IĂ낵ł?",
	"ImF",
	"ċNĂ낵ł?",
	"ύX͍ċNɗLƂȂ܂B\nċN܂?",
	"ċNmF",
	"gROM}ăZbg܂B",
	"gROMroăZbg܂B",
	"ZbgmF"
};

// j[pbZ[W ------
const char *MsgMen[] = {
	"rfILv`...",
	"rfILv`~",
	"L^...",	// (vC)
	"L^~",	// (vC)
	"Đ...",	// (vC)
	"Đ~"	// (vC)	
};

// INIt@CpbZ[W ------
const char *MsgIni[] = {
	// [CONFIG]
	"; === PC6001V ݒt@C ===\n\n",
	"@ 60:PC-6001 62:PC-6001mk2 66:PC-6601 64:PC-6001mk2SR 68:PC-6601SR",
	"FDDڑ䐔 (0-2)",
	"gRAMgp",
	"Turbo TAPE Yes:L No:",
	"BoostUp Yes:L No:",
	"BoostUp ő{(N60[h)",
	"BoostUp ő{(N60m/N66[h)",
	"I[o[NbN (1-1000)%",
	"CRC`FbN Yes:L No:",
	"ROMpb` Yes:Ă No:ĂȂ",
	// [DISPLAY]
	"J[[h 8:8bit 16:16bit 24:24bit",
	"MODE4J[[h 0:mN 1:/ 2:/ 3:sN/ 4:/sN",
	"XLC Yes: No:Ȃ",
	"XLCPx (0-100)%",
	"4:3\\ Yes:L No:",
	"tXN[[h Yes:L No:",
	"Xe[^Xo[ Yes:\\ No:\\",
	"t[XLbv",
	// [SOUND]
	"TvO[g (44100/22050/11025)Hz",
	"TEhobt@TCY",
	"}X^[ (0-100)",
	"PSG (0-100)",
	" (0-100)",
	"TAPEj^ (0-100)",
	"PSG LPFJbgItg(0Ŗ)",
	// [MOVIE]
	"RLEtO Yes:RLEL No:x^",
	// [FILES]
	"gROMt@C",
	"TAPE(LODE)t@C(NɎ}Eg)",
	"TAPE(SAVE)t@C(SAVEɎ}Eg)",
	"DISKt@C(NɎ}Eg)",
	"v^o̓t@C",
	"SptHgt@C",
	"ptHgt@C",
	// [PATH]
	"ROMC[Wi[pX",
	"TAPEC[Wi[pX",
	"DISKC[Wi[pX",
	"gROMC[Wi[pX",
	"XibvVbgi[pX",
	"WAVEt@Ci[pX",
	"FONTi[pX",
	// [CHECK]
	"ImF Yes: No:Ȃ",
	"IINIt@Cۑ Yes: No:Ȃ",
	// [KEY]
	"L[s[g̊Ԋu(P:ms 0Ŗ)",
	"PS/2L[{[hg? Yes:PS/2 No:USB",
	// [OPTION]
	"m̃J[gbW Yes:L No:"
	
};

// ǂłSAVEpbZ[W ------
const char *MsgDok[] = {
	"; === PC6001V ǂłSAVEt@C ===\n\n"
};

// ErrorpbZ[W ------
const char *MsgErr[] = {
	"Error",
	"G[͂܂",
	"s̃G[܂",
	"̊mۂɎs܂",
	"w肳ꂽ@ROMC[WȂߋ@ύX܂\nݒmFĂ",
	"ROMC[W܂\nݒƃt@CmFĂ",
	"ROMC[W̃TCYsł",
	"ROMC[WCRCsł",
	"Cu(SDL)̏Ɏs܂",
	"Ɏs܂\nݒmFĂ",
	"tHg̓Ǎ݂Ɏs܂",
	"INIt@C̓Ǎ݂Ɏs܂\nftHgݒŋN܂",
	"INIt@C̓Ǎ݂Ɏs܂",
	"INIt@C̕ۑɎs܂",
	"TAPEC[W̃}EgɎs܂",
	"DISKC[W̃}EgɎs܂",
	"gROMC[W̃}EgɎs܂",
	"ǂłLOADɎs܂",
	"ǂłSAVEɎs܂",
	"ǂłLOADɎs܂\nۑƋ@킪قȂ܂",
	"ǂłLOADɎs܂\nۑPC6001Ṽo[WقȂ܂",
	"vCĐɎs܂",
	"vCĐɎs܂\nۑƋ@킪قȂ܂",
	"vCL^Ɏs܂",
	"vCf[^܂"
};



////////////////////////////////////////////////////////////////
// ɂ镶r
//
// :	s1			r镶ւ̃|C^1
//			s2			r镶ւ̃|C^2
// Ԓl:	int			0: :s1>s2 :s1<s2
////////////////////////////////////////////////////////////////
int stricmp ( const char *s1, const char *s2 )
{
	const char *ps1 = s1, *ps2 = s2;
	
	if( !s1 ) return -1;
	if( !s2 ) return  1;
	
	// 擪̕
	char c1 = *ps1++;
	char c2 = *ps2++;
	
	// ǂ炩̕I[܂ŌJԂ
	while( c1 && c2 ){
		// ɕϊ
		if( c1 >= 'A' && c1 <= 'Z' ) c1 += 'a' - 'A';
		if( c2 >= 'A' && c2 <= 'Z' ) c2 += 'a' - 'A';
		
		// ȂrI
		if( c1 != c2 ) break;
		
		// ̕擾
		c1 = *ps1++;
		c2 = *ps2++;
	}
	
	return (int)c1 - (int)c2;
}

////////////////////////////////////////////////////////////////
// pX̃f~^'/'ɕϊ
//
// :	path		pXi[obt@|C^
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void Delimiter( char *path )
{
	while( char *c = strchr( path, '\\') )
		*c = '/';
}


////////////////////////////////////////////////////////////////
// pX̃f~^'\'ɕϊ
//
// :	path		pXi[obt@|C^
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void UnDelimiter( char *path )
{
#ifdef WIN32
	while( char *c = strchr( path, '/') )
		*c = '\\';
#endif
}


////////////////////////////////////////////////////////////////
// pX̖Ƀf~^ǉ
//
// :	path		pXi[obt@|C^
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void AddDelimiter( char *path )
{
	if( !strlen( path ) )
		strncpy( path, "/", PATH_MAX );
	else if( (path[strlen(path)-1] != '/' ) && ( path[strlen(path)-1] != '\\') )
		strncat( path, "/", PATH_MAX );
}


////////////////////////////////////////////////////////////////
// pX̖̃f~^폜
//
// :	path		pXi[obt@|C^
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void DelDelimiter( char *path )
{
	if( strlen( path ) > 1 )
		while( ( path[strlen(path)-1] == '/' ) || ( path[strlen(path)-1] == '\\' ) )
			path[strlen(path)-1] = '\0';
}



////////////////////////////////////////////////////////////////
// dN`FbN
//
// :	Ȃ
// Ԓl:	BOOL		TRUE:Nς FALSE:N
////////////////////////////////////////////////////////////////
BOOL OSD_IsWorking( void )
{
#ifdef WIN32						// Ƃ肠A֏͗pӂ@by Windy
	// CEBhENX̖O
	#define	MWCLASS	"p6vmainw"
	
	PRINTD( OSD_LOG, "[OSD][OSD_IsWorking]\n" );
	
	HANDLE hCheckMutex = OpenMutex( MUTEX_ALL_ACCESS, FALSE, MWCLASS );
	if( hCheckMutex ){
		CloseHandle( hCheckMutex );
		return TRUE;
	}
	hMutex = CreateMutex( FALSE, 0, MWCLASS );
#endif
	return FALSE;
}


////////////////////////////////////////////////////////////////
// I
//
// :	Ȃ
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void OSD_Finish( void )
{
	PRINTD( OSD_LOG, "[OSD][OSD_Finish]\n" );
#ifdef WIN32
	// Mutex J
	ReleaseMutex( hMutex );
#endif
}

//	static char mpath[PATH_MAX] = "";	// W[pX擾p

////////////////////////////////////////////////////////////////
// W[pX擾
//
// :	Ȃ
// Ԓl:	char *		擾ւ̃|C^
////////////////////////////////////////////////////////////////
const char *OSD_GetModulePath( void )
{
	PRINTD( OSD_LOG, "[OSD][OSD_GetModulePath]\n" );
	
	static char mpath[PATH_MAX] = "";	// W[pX擾p
	char tmp[PATH_MAX] = "";	//  tmp

#ifdef WIN32
	char Drive[3];
	char Dir[PATH_MAX];
	
	int num = GetModuleFileName( NULL, mpath, PATH_MAX );
	_splitpath( mpath, Drive, Dir, NULL, NULL );
	sprintf( mpath, "%s%s", Drive, Dir );
	if( num ) Delimiter( mpath );
	AddDelimiter( mpath );	// Ô
#endif
#ifdef __APPLE__				// OSɁAst@C̃pX₢킹

	if(mpath[0]==0)
		{
		CFURLRef bundleURL;
		FSRef bundleFS;
		char bundleCString[PATH_MAX];

		bundleURL = CFBundleCopyBundleURL(CFBundleGetMainBundle());
		CFURLGetFSRef(bundleURL, &bundleFS);
		FSRefMakePath(&bundleFS, (UInt8*)bundleCString, PATH_MAX);
		CFRelease(bundleURL);

		strncpy(tmp,  bundleCString ,PATH_MAX);
		strcat(tmp, "/../");

		chdir( tmp);							// change directory to  mpath
		getcwd( tmp, PATH_MAX);				// get current directory
		strcat( tmp, "/");					// add delimiter
		strncpy( mpath , OSD_UTF8toSJIS( tmp) ,PATH_MAX);   // convert UTF-8 to SJIS 
		}
	printf("mpath='%s'\n",mpath);
	
#endif
	return mpath;
}

////////////////////////////////////////////////////////////////
// Nt@C (argv[0]) @W[ݒ肷
//
// :	path		tpXi[obt@|C^
////////////////////////////////////////////////////////////////
void OSD_SetModulePath( const char *path)
{

#ifndef WIN32
//    char  curdir[ PATH_MAX];
//	const char *p;
//	unsigned int i;

//	// ----------- Nt@CAfBNg擾 ------
//	p= &path[ strlen(path)-1];
//	for(i= strlen(path)-1; i >=0 ; i--) 
//	   {
//	   if( *p =='/')          // 납f~^TāAt@C菜 @search delimiter
//           {
//              i++;
//	      break;
//           }
//            p--;
//	   }
	
	// ------------- fBNgW[ɕϊ ----------------
//	mpath[0]=0;
//	if( path[0]!='/')			// ΃pX̏ꍇB@ relative path@
//		{									// fullpath = current directory + relative path
//		 getcwd( curdir,PATH_MAX);	        // get current directory
//		 strncat( mpath , curdir, PATH_MAX);// add current directory
//		 strcat(  mpath , "/");				// add delimiter
//		 strncat( mpath , path ,i);			// add relative path
//		}
//	else						// tpX̏ꍇ@B@@full path 
//		{
//		strncat( mpath , path,i);			// copy directory only
//		}
//		
//	strcat( mpath , "../../../");           // pc60001v.app ̂fBNgZbg@@set pc6001v.app 's directory

							// ΃pX܂ރpXASȃtpXɕϊ@@@convert relative path to full path
//	chdir( mpath);							// change directory to  mpath
//	getcwd( mpath, PATH_MAX);				// get current directory
//	strcat( mpath, "/");					// add delimiter
//	
	// SJIS ɕϊ by KN 2004/11/1
//	strcpy( mpath, OSD_UTF8toSJIS( mpath ));

#ifdef DEBUG
	printf("Module Path is %s \n",mpath);
#endif
#endif
}

////////////////////////////////////////////////////////////////
// tpXt@C擾
//
// :	path		tpXi[obt@|C^
// Ԓl:	char *		t@C̊Jn|C^
////////////////////////////////////////////////////////////////
const char *OSD_GetFileNamePart( const char *path )
{
	PRINTD( OSD_LOG, "[OSD][OSD_GetFileNamePart]\n" );
	
#ifdef WIN32
	char Drive[3];
	char Dir[PATH_MAX];
	
	_splitpath( path, Drive, Dir, NULL, NULL );
	
	return &path[strlen( Drive ) + strlen( Dir )];
#else
	const char *p;			// t@C̐؂óAnI@őp@@by Windy
	unsigned int i;
	p= &path[ strlen(path)-1];
	for(i= 0 ; i < strlen(path); i++) 
	   {
	   if( *p =='/')          // search delimiter
             {
              p++;
              break;
             }
            p--;
	   }
        
       return( p );
#endif
}


////////////////////////////////////////////////////////////////
// t@C̑݃`FbN
//
// :	path		tpXi[obt@|C^
// Ԓl:	BOOL		TRUE:݂ FALSE:݂Ȃ
////////////////////////////////////////////////////////////////
BOOL OSD_FileExist( const char *fullpath )
{
	PRINTD( OSD_LOG, "[OSD][OSD_FileExist]\n" );
#ifdef WIN32
	
	char filename[PATH_MAX+1];
	WIN32_FIND_DATA FindFileData;
	HANDLE hFind;
	BOOL ret = FALSE;
	
	strncpy( filename, fullpath, PATH_MAX );
	
	DelDelimiter( filename );
	UnDelimiter( filename );
	
	hFind = FindFirstFile( filename, &FindFileData );
	if( hFind != INVALID_HANDLE_VALUE ) ret = TRUE;
	FindClose( hFind );
	
	return ret;
#else				// t@C݂邩ǂAfopen őp by Windy
	BOOL ret=FALSE;
	FILE *fp;
	//fp = fopen( SJIStoUTF8( fullpath ), "r");
	fp = FOPENEN( fullpath, "r");
	if( fp != NULL)	
           {
            ret= TRUE;
            fclose(fp);
           }
        return ret;
#endif
	
}


///////////////////////////////////////////////////////////
// tH_̎Q
//
// :	hwnd		ẽEBhEnh
//			Result		tH_ւ̃pXi[obt@|C^
// Ԓl:	char *		擾ւ̃|C^
///////////////////////////////////////////////////////////
const char *OSD_FolderDiaog( void *hwnd, char *Result )
{
#ifdef WIN32
	LPMALLOC Memory;
	LPITEMIDLIST Ret, Root;
	char Buffer[PATH_MAX];
	
	//VFIMallocC^tF[XɃ|C^擾
	SHGetMalloc( &Memory );
	
	//u}CRs[^vtH_̈ʒu擾
	SHGetSpecialFolderLocation( (HWND)hwnd, CSIDL_DRIVES, &Root );
	
	// tH_̃pX
	UnDelimiter( Result );
	
	//BrowseInfo\̂̏ݒ
	ZeroMemory( &OBI, sizeof(BROWSEINFO) );
	OBI.hwndOwner = (HWND)hwnd;			// eEChẼnh
	OBI.pidlRoot  = Root;				// [gtH_(CSIDL_~~)
	OBI.ulFlags   = BIF_STATUSTEXT | BIF_RETURNONLYFSDIRS;	// tH_̃^CvtO(BIF_~~)
	OBI.lpszTitle = "tH_IĂB";			// ^Cgij
	OBI.pszDisplayName = Buffer;		// (߂l)tH_
	OBI.lpfn = OsdBrowseCallbackProc;	// R[obN֐̃Gg|Cg
	OBI.lParam = (LPARAM)Result;		// R[obN֐ɓn
    	
	//utH_̎QƁv_CAO\
	Ret = SHBrowseForFolder( &OBI );
	
	if( SHGetPathFromIDList( Ret, Buffer ) ){
		//̉
		Memory->Free( Ret );
		Memory->Free( Root );
		
		lstrcpyn( Result, Buffer, PATH_MAX-1 );
		DelDelimiter( Result );
		UnDelimiter( Result );
		return Result;
	}else{
		//̉
		Memory->Free( Ret );
		Memory->Free( Root );
		
		return NULL;
	}
#else
      return( NULL);
#endif
}

#ifdef WIN32

// OSD_FolderDiaog()ŎgpR[obNvV[W
static BOOL CALLBACK OsdBrowseCallbackProc( HWND hwnd, UINT msg, LPARAM lp1, LPARAM lp2 )
{
	char Path[PATH_MAX*2];	// Ô2{?
	
	// BIF_STATUSTEXTȊO͉Ȃ
	if( OBI.ulFlags & BIF_STATUSTEXT ){
		switch( msg ){
		case BFFM_INITIALIZED:	// 
			// tH_ݒ
			SendMessage( hwnd, BFFM_SETSELECTION, (WPARAM)TRUE, lp2 );
			break;
		case BFFM_SELCHANGED:	// [U[tH_ύX
			// ITEMIDLIST\̂pXo
			SHGetPathFromIDList( (LPCITEMIDLIST)lp1, Path );
			// ύXꂽtH_̃pX\
			SendMessage( hwnd, BFFM_SETSTATUSTEXT, 0, (LPARAM)Path );
		}
	}
	return FALSE;
}
#endif

///////////////////////////////////////////////////////////
// t@C̎Q
//
// :	hwnd		ẽEBhEnh
//			mode		[h FM_Load:t@CJ FM_Save:Otĕۑ
//			title		EBhELvVւ̃|C^
//			filter		t@CtB^ւ̃|C^
//			fullpath	tpXi[obt@|C^
//			path		t@CpXi[obt@|C^
//			ext			gqւ̃|C^
// Ԓl:	char *		擾t@Cւ̃|C^(tpXł͂Ȃ)
///////////////////////////////////////////////////////////
const char *OSD_FileDiaog( void *hwnd, FileMode mode, const char *title, const char *filter, char *fullpath, char *path, const char *ext )
{
#ifdef WIN32
	OPENFILENAME fname;
	char File[PATH_MAX] = "";
	char Path[PATH_MAX] = "";
	BOOL ret = FALSE;
	
	if( !fullpath ) return NULL;
	
	if( OSD_FileExist( fullpath ) ){
		strncpy( File, fullpath, PATH_MAX );
		UnDelimiter( File );
	}else if( path ){
		strncpy( Path, path,     PATH_MAX );
		UnDelimiter( Path );
	}
	
	ZeroMemory( &fname, sizeof(OPENFILENAME) );
	
	fname.lStructSize     = sizeof(OPENFILENAME);
	fname.hwndOwner       = (HWND)hwnd;		// ẽEBhEnh
	fname.lpstrFilter     = filter;			// t@CtB^
	fname.nFilterIndex    = 1;				// 1Ԗڂ̃t@CtB^g
	fname.lpstrFile       = File;			// IꂽtpX̊i[
	fname.nMaxFile        = sizeof(File);	// ̃TCY
	fname.lpstrInitialDir = Path;			// tH_
	fname.lpstrTitle      = title;			// ^Cg
	fname.lpstrDefExt     = ext;			// gqȗĂꍇɒǉgq
//	fname.Flags           = OFN_PATHMUSTEXIST | OFN_HIDEREADONLY | OFN_LONGNAMES;
	
	if( mode == FM_Save ){
		fname.Flags = OFN_OVERWRITEPROMPT | OFN_HIDEREADONLY | OFN_LONGNAMES;
		ret = GetSaveFileName( &fname );
	}else{
		fname.Flags = OFN_PATHMUSTEXIST | OFN_HIDEREADONLY | OFN_LONGNAMES;
		ret = GetOpenFileName( &fname );
	}
	
	if( ret ){
		Delimiter( File )
		// pXۑ
		if( path ) strncpy( path, File, fname.nFileOffset );
		// tpXۑ
		if( fullpath ) strncpy( fullpath, File, PATH_MAX );
		// t@Cւ̃|C^Ԃ
		return fullpath + fname.nFileOffset;
	}else
		return NULL;
#endif
#ifdef __APPLE__
	// this part is written by Koichi Nishida 2004/10/18
	// cOȂt@C_CAOł̎w@悭킩Ȃ̂ŁA
	// filterApathAext ͖܂BBB

	OSStatus err;
	
	// _CAÔ߂̕ϐ
	NavDialogRef theDialog;
	CFStringRef CFTitle;
	NavDialogCreationOptions dialogOptions;
	NavReplyRecord reply;
	AEDesc actualDesc;
	FSRef fileToOpen;
	HFSUniStr255 uniFileNameChars;
	CFStringRef CFFileName;
	
	// ŏIIɃt@C
	static char fileName[PATH_MAX];
	fileName[0]=0;

	// _CAOŝ߂̏
	err = NavGetDefaultDialogCreationOptions( &dialogOptions );
	require_noerr( err, CantGetDialogOptions );
	dialogOptions.modality = kWindowModalityAppModal;	// AvP[V_[
	// ^CgZbg
	CFTitle = CFStringCreateWithCString( NULL , title , kCFStringEncodingShiftJIS_X0213_00 );
	dialogOptions.windowTitle = CFTitle;
	
	// _CAO
	if ( mode == FM_Save ) {
		err = NavCreatePutFileDialog( &dialogOptions, NULL, NULL, NULL, NULL, &theDialog );
		require_noerr( err, CantCreateDialog );
	} else {
		err = NavCreateGetFileDialog( &dialogOptions, NULL, NULL, NULL, NULL, NULL, &theDialog );
		require_noerr( err, CantCreateDialog );
	}
	
	// _CAOs
	err = NavDialogRun( theDialog );
	require_noerr( err, CantDoNavDialogRun );	
	
	// _CAǑʂǂ
	err = NavDialogGetReply( theDialog, &reply );
	//require_noerr( err, CantDoNavDialogRun );
	if( err ) {							// LZꂽA[āA@@ 2004/12/24
		NavDialogDispose( theDialog );
		CFRelease( CFTitle);
		return( NULL);
		}
	
	err = AECoerceDesc( &reply.selection, typeFSRef, &actualDesc );
	require_noerr( err, CantDoNavDialogRun );
	err = AEGetDescData( &actualDesc, (void*)(&fileToOpen), sizeof(FSRef) );
	require_noerr( err, CantDoNavDialogRun );

	// t@C𓾂
	if ( mode == FM_Save )	{
		char dir[MAX_PATH];
		CFStringGetCString( reply.saveFileName, fileName, PATH_MAX, kCFStringEncodingUTF8 );
		// tpX𓾂
		err = FSRefMakePath( &fileToOpen, (UInt8*)dir, PATH_MAX );
		sprintf(fullpath, "%s/%s", dir, fileName);
	} else {
		err = FSGetCatalogInfo( &fileToOpen, kFSCatInfoNone, NULL, &uniFileNameChars, NULL, NULL );
		require_noerr( err, CantGetFileName );
		CFFileName = CFStringCreateWithCharacters( NULL, uniFileNameChars.unicode, uniFileNameChars.length );
		CFStringGetCString( CFFileName, fileName, PATH_MAX, kCFStringEncodingUTF8 );

		// tpX𓾂
		err = FSRefMakePath( &fileToOpen, (UInt8*)fullpath, PATH_MAX );
		CFRelease ( CFFileName );
	}

CantGetFileName:
	AEDisposeDesc( &actualDesc );	
	NavDisposeReply( &reply);		// ʂ  2004/12/24
CantDoNavDialogRun:
	NavDialogDispose( theDialog ); 
CantCreateDialog:
	CFRelease( CFTitle );
CantGetDialogOptions:
	strcpy( fullpath, OSD_UTF8toSJIS( fullpath ) );
	strcpy( fileName, OSD_UTF8toSJIS( fileName ) );
return fileName;
#endif
}


////////////////////////////////////////////////////////////////
// et@CI
//
// :	hwnd		ẽEBhEnh(NULL̏ꍇ̓XN[T[tFX̃nh擾݂)
//			type		_CAO̎(FileDlgQ)
//			fullpath	tpXi[obt@|C^
//			path		t@CpXi[obt@|C^
// Ԓl:	char *		擾t@Cւ̃|C^(tpXł͂Ȃ)
////////////////////////////////////////////////////////////////
const char *OSD_FileSelect( void *hwnd, FileDlg type, char *fullpath, char *path )
{
#ifdef WIN32
	HWND shwnd    = (HWND)hwnd;
#endif
#ifdef __APPLE__
	void *shwnd = hwnd;
#endif
	FileMode mode = FM_Load;
	char *title   = NULL;
	char *filter  = NULL;
	char *ext     = NULL;
	
	switch( type ){
	case FD_TapeLoad:	// TAPE(LOAD)I
		mode   = FM_Load;
		title  = "TAPE(LOAD)J";
		filter = "TAPEC[W\0*.p6t;*.cas;*.p6\0"
    			 "P6T` (*.p6t)\0*.p6t\0"
    			 "x^` (*.cas;*.p6)\0*.cas\0"
    			 "SẴt@C (*.*)\0*.*\0\0";
		ext    = "p6t";
		break;
		
	case FD_TapeSave:	// TAPE(SAVE)I
		mode   = FM_Save;
		title  = "TAPE(SAVE)J";
		filter = "TAPEC[W\0*.p6t;*.cas;*.p6\0"
    			 "P6T` (*.p6t)\0*.p6t\0"
    			 "x^` (*.cas;*.p6)\0*.cas\0"
    			 "SẴt@C (*.*)\0*.*\0\0";
		ext    = "p6t";
		break;
		
	case FD_Disk:		// DISKI
		mode   = FM_Load;
		title  = "DISKJ";
		filter = "DISKC[W\0*.d88\0"
				 "D88` (*.d88)\0*.d88\0"
				 "SẴt@C (*.*)\0*.*\0\0";
		ext    = "d88";
		break;
		
	case FD_ExtRom:		// gROMI
		mode   = FM_Load;
		title  = "gROMC[WI";
		filter = "SẴt@C (*.*)\0*.*\0\0";
		break;
		
	case FD_Printer:	// v^[o̓t@CI
		mode   = FM_Save;
		title  = "v^[o̓t@CI";
		filter = "SẴt@C (*.*)\0*.*\0\0";
		ext    = "txt";
		break;
		
	case FD_FontZ:		// SptHgt@CI
		mode   = FM_Load;
		title  = "SptHgt@CI";
		filter = "PNGt@C (*.png)\0*.png\0"
				 "SẴt@C (*.*)\0*.*\0\0";
		ext    = "png";
		break;
		
	case FD_FontH:		// ptHgt@CI
		mode   = FM_Load;
		title  = "ptHgt@CI";
		filter = "PNGt@C (*.png)\0*.png\0"
				 "SẴt@C (*.*)\0*.*\0\0";
		ext    = "png";
		break;
		
	case FD_DokoLoad:	// ǂłLOADt@CI
		mode   = FM_Load;
		title  = "ǂłLOADt@CI";
		filter = "ǂłSAVE` (*.dds)\0*.dds\0"
				 "SẴt@C (*.*)\0*.*\0\0";
		ext    = "dds";
		break;
		
	case FD_DokoSave:	// ǂłSAVEt@CI
		mode   = FM_Save;
		title  = "ǂłSAVEt@CI";
		filter = "ǂłSAVE` (*.dds)\0*.dds\0"
				 "SẴt@C (*.*)\0*.*\0\0";
		ext    = "dds";
		break;

	case FD_RepLoad:	// vCĐt@CI
		mode   = FM_Load;
		title  = "vCĐt@CI";
		filter = "vCt@C (*.ddr)\0*.ddr\0"
				 "SẴt@C (*.*)\0*.*\0\0";
		ext    = "ddr";
		break;
		
	case FD_RepSave:	// vCۑt@CI
		mode   = FM_Save;
		title  = "vCۑt@CI";
		filter = "vCt@C (*.ddr)\0*.ddr\0"
				 "SẴt@C (*.*)\0*.*\0\0";
		ext    = "ddr";
		break;
		

	case FD_AVISave:	// rfILv`o̓t@CI
		mode   = FM_Save;
		title  = "rfILv`o̓t@CI";
		filter = "AVIt@C (*.avi)\0*.avi\0"
				 "SẴt@C (*.*)\0*.*\0\0";
		ext    = "avi";
		break;
		
	default:		// ėp
		mode   = FM_Load;
		title  = "t@CJ";
		filter = "SẴt@C (*.*)\0*.*\0\0";
		break;
	}
#ifdef WIN32	// by KN
	// EBhEnh NULL ,XN[T[tFX̃nh擾݂
	if( !hwnd ){
		SDL_SysWMinfo WinInfo;
		SDL_VERSION( &WinInfo.version );
		shwnd = SDL_GetWMInfo( &WinInfo ) ? WinInfo.window : NULL;
	}
#endif
	return OSD_FileDiaog( shwnd, mode, title, filter, fullpath, path, ext );
}


#ifdef __APPLE__

#if 0
// {^Cxgnh
static pascal OSStatus DialogButtonEventHandler( EventHandlerCallRef inHandlerRef,
	EventRef inEvent, void *ret )
{
	OSStatus result = eventNotHandledErr;
	HICommand command;
	
	GetEventParameter( inEvent, kEventParamDirectObject, typeHICommand, NULL,
		sizeof( HICommand ), NULL, &command );
	switch ( command.commandID ) {	
		case 'ok  ':	// OK {^
			*(int *)ret = OSDR_OK;
			QuitApplicationEventLoop(); // {^ꂽ_ŃCxg[v𔲂
			result = noErr;
			break;
		case 'not!':	// Cancel {^
			*(int *)ret = OSDR_CANCEL;
			QuitApplicationEventLoop();	// 
			result = noErr;
			break;
		case 'Yes ':	// Yes {^
			*(int *)ret = OSDR_YES;
			QuitApplicationEventLoop();	// 
			result = noErr;
			break;
		case 'No  ':	// No {^
			*(int *)ret = OSDR_NO;
			QuitApplicationEventLoop();	// 
			result = noErr;
			break;
	}
	return result;
}
#endif
#endif

////////////////////////////////////////////////////////////////
// bZ[W\
//
// :	mes			bZ[Wւ̃|C^
//			cap			EBhELvVւ̃|C^
//			type		\`w̃tO
// Ԓl:	int			ꂽ{^̎
//							OSDR_OK:     OK{^
//							OSDR_CANCEL: CANCEL{^
//							OSDR_YES:    YES{^
//							OSDR_NO:     NO{^
////////////////////////////////////////////////////////////////
int OSD_Message( const char *mes, const char *cap, int type )
{
#ifdef WIN32
	int Type = MB_OK;
	
	// bZ[W{bNX̃^Cv
	switch( type&0x000f ){
	case OSDM_OK:			Type = MB_OK;			break;
	case OSDM_OKCANCEL:		Type = MB_OKCANCEL;		break;
	case OSDM_YESNO:		Type = MB_YESNO;		break;
	case OSDM_YESNOCANCEL:	Type = MB_YESNOCANCEL;	break;
	}
	
	// bZ[W{bNX̃ACR^Cv
	switch( type&0x00f0 ){
	case OSDM_ICONERROR:	Type |= MB_ICONERROR;		break;
	case OSDM_ICONQUESTION:	Type |= MB_ICONQUESTION;	break;
	case OSDM_ICONWARNING:	Type |= MB_ICONWARNING;		break;
	case OSDM_ICONINFO:		Type |= MB_ICONINFORMATION;	break;
	}
	
	// eEBhE̓XN[T[tFXƌߑł
	SDL_SysWMinfo WinInfo;
	SDL_VERSION( &WinInfo.version );
	HWND hwnd = SDL_GetWMInfo( &WinInfo ) ? WinInfo.window : NULL;
	
	int res = MessageBox( hwnd, mes, cap, Type | MB_TOPMOST );
	
	switch( res ){
	case IDOK:	return OSDR_OK;
	case IDYES:	return OSDR_YES;
	case IDNO:	return OSDR_NO;
	default:	return OSDR_CANCEL;
	}
#endif

#ifdef __APPLE__
/* excluded by KN
	{
	DialogRef theItem;
	DialogItemIndex itemIndex;

	CFStringRef mes_str;
	CFStringRef cap_str;
									// C string ACFString ɕϊ  (Shift JIS)
	cap_str = CFStringCreateWithCString( NULL , cap , kCFStringEncodingShiftJIS_X0213_00);
	mes_str = CFStringCreateWithCString( NULL , mes , kCFStringEncodingShiftJIS_X0213_00);
									// Alert dialog ̏
	CreateStandardAlert( kAlertStopAlert , 
		cap_str, 
		mes_str,
		NULL, &theItem);
		
	RunStandardAlert (theItem, NULL, &itemIndex);   // Alert dialog ̕\
	CFRelease( cap_str);
	CFRelease( mes_str);
	printf("MessageBox %s   %s  \n",mes,cap);
	}
  return OSDR_OK;
*/
	// this part is written by Koichi Nishida 2004/12/22
	DialogRef theItem;
	DialogItemIndex itemIndex;
	CFStringRef capStr, mesStr;
	AlertStdCFStringAlertParamRec param;
	AlertType aType =0;

	GetStandardAlertDefaultParams(&param, kStdCFStringAlertVersionOne);
	// bZ[W{bNX̃^Cv
	switch( type&0x000f ){
	case OSDM_OKCANCEL:
		param.cancelText = CFSTR( "Cancel" );
		break;
	case OSDM_YESNO:
		param.defaultText = CFSTR( "Yes" );
		param.cancelText = CFSTR( "No" );
		break;
	case OSDM_YESNOCANCEL:
		param.defaultText = CFSTR( "Yes" );
		param.cancelText = CFSTR( "No" );
		param.otherText = CFSTR( "Cancel" );
		break;
	// case OSDM_OK: // ftHg
	  default:
		break;
	}	
	// bZ[W{bNX̃ACR^Cv
	switch( type&0x00f0 ){
	case OSDM_ICONERROR:
		aType = kAlertStopAlert; break;
	case OSDM_ICONQUESTION:
		aType = kAlertNoteAlert; break;
	case OSDM_ICONWARNING:
		aType = kAlertCautionAlert; break;
	  case OSDM_ICONINFO:
		aType = kAlertPlainAlert; break;
	}
	capStr = CFStringCreateWithCString( NULL, cap, kCFStringEncodingShiftJIS_X0213_00 );
	mesStr = CFStringCreateWithCString( NULL, mes, kCFStringEncodingShiftJIS_X0213_00 );
	CreateStandardAlert( aType, capStr, mesStr, &param, &theItem );
	RunStandardAlert ( theItem, NULL, &itemIndex );   // Alert dialog ̕\
	CFRelease( capStr );
	CFRelease( mesStr );
	switch( type&0x000f ){
	case OSDM_OKCANCEL:
		switch( itemIndex ){
		case 1: return OSDR_OK;
		default: return OSDR_CANCEL;
		}
	case OSDM_YESNO:
		switch( itemIndex ){
		case 1: return OSDR_YES;
		default: return OSDR_NO;
		}
	case OSDM_YESNOCANCEL:
		switch( itemIndex ){
		case 1: return OSDR_YES;
		case 2: return OSDR_NO;
		default: return OSDR_CANCEL;
		}
	// case OSDM_OK: // ftHg
	 default:
		return OSDR_OK;
	}
#endif
}

////////////////////////////////////////////////////////////////
// L[{[h^Cv擾
//
// :	useps2		TRUE:PS/2L[{[hg FALSE:USBL[{[hg
// Ԓl:	int			L[{[h^Cv
////////////////////////////////////////////////////////////////
int OSD_GetKeyboardType( int useps2 )
{
#ifndef __APPLE__
	char vdname[64];
	
	if( !SDL_VideoDriverName( vdname, sizeof(vdname) ) ) return KB_UNKNOWN;
	
	if( !stricmp( "windib",  vdname ) ) return useps2 ? KB_PS2WD : KB_USBWD;
	if( !stricmp( "directx", vdname ) ) return useps2 ? KB_PS2DX : KB_USBDX;

	
	return KB_UNKNOWN;
#endif
    return 0;

}


////////////////////////////////////////////////////////////////
// L[R[h␳
//
// :	scode		SDL̃L[R[h
//			hcode		n[hEFAL̃XLR[h
// Ԓl:	int			␳SDL̃L[R[h
////////////////////////////////////////////////////////////////
//int OSD_KeyCodeFix( int scode, BYTE hcode ,int kbdtype)
int OSD_KeyCodeFix( int scode, BYTE hcode )
{
	int fcode = scode;
	
#ifndef __APPLE__
	switch( OSD_GetKeyboardType() ){
	case KB_DIRECTX:	// directx
		switch( hcode ){
		case 0x2b:	fcode = SDLK_UNDERSCORE;	break;	// _
		case 0x7d:	fcode = SDLK_BACKSLASH;		break;	// 
		case 0x90:	fcode = SDLK_CARET;			break;	// ^
		case 0x91:	fcode = SDLK_AT;			break;	// @
		case 0x92:	fcode = SDLK_COLON;			break;	// :
		case 0x94:	fcode = SDLK_BACKQUOTE;		break;	// p/Sp
		}
		break;
		
	case KB_WINDIB:		// windib
		switch( hcode ){
		case 0x0d:	fcode = SDLK_CARET;			break;	// ^
		case 0x1a:	fcode = SDLK_AT;			break;	// @
		case 0x1b:	fcode = SDLK_LEFTBRACKET;	break;	// [
		case 0x28:	fcode = SDLK_COLON;			break;	// :
		case 0x2b:	fcode = SDLK_RIGHTBRACKET;	break;	// ]
		case 0x73:	fcode = SDLK_UNDERSCORE;	break;	// _
		}
		break;
	}
	
#else

	switch( hcode ){	// n[hEFAL̃XLR[h
	case 0x68:	fcode = SDLK_PAUSE;			break;	// 
	}
#endif
	
	return fcode;
}


////////////////////////////////////////////////////////////////
// F̖O擾
//
// :	num			FR[h
// Ԓl:	char *		F̖Oւ̃|C^
////////////////////////////////////////////////////////////////
const char *OSD_ColorName( int num )
{
	static const char *JColorName[] = {
		"MODE1,2 ({[_[)",
		"MODE1 Set1 ",		"MODE1 Set1 ",		"MODE1 Set2 ",		"MODE1 Set2 IW",
		"MODE2 ",				"MODE2 ",				"MODE2 ",				"MODE2 ",
		"MODE2 ",				"MODE2 VA",			"MODE2 }[^",		"MODE2 IW",
		"MODE3 Set1 ",		"MODE3 Set1 ",		"MODE3 Set1 ",		"MODE3 Set1 ",
		"MODE3 Set2 ",		"MODE3 Set2 VA",	"MODE3 Set2 }[^",	"MODE3 Set2 IW",
		"MODE4 Set1 ",		"MODE4 Set1 ",		"MODE4 Set2 ",		"MODE4 Set2 ",
		"MODE4 Set1 ɂ ",	"MODE4 Set1 ɂ ",	"MODE4 Set1 ɂ -",	"MODE4 Set1 ɂ -",
		"MODE4 Set2 ɂ ",	"MODE4 Set2 ɂ ",	"MODE4 Set2 ɂ ",	"MODE4 Set2 ɂ ",
		"mk2` ()",		"mk2` ",				"mk2` ",			"mk2` ",
		"mk2` ",			"mk2` Ԏ",			"mk2` F",			"mk2` DF",
		"mk2` ",				"mk2` ",				"mk2` ",				"mk2` ",
		"mk2` ",				"mk2` }[^",		"mk2` VA",			"mk2` " };
	
	if( num < 0 || num >= COUNTOF( JColorName ) ) return NULL;
	else                                          return JColorName[num];
}

////////////////////////////////////////////////////////////////
// L[̖O擾
//
// :	sym			zL[R[h
// Ԓl:	char *		L[Oւ̃|C^
////////////////////////////////////////////////////////////////
const char *OSD_KeyName( PCKEYsym sym )
{
	static const PCKeyName kname[] = {
		{ KVC_1,			"1" },
		{ KVC_2,			"2" },
		{ KVC_3,			"3" },
		{ KVC_4,			"4" },
		{ KVC_5,			"5" },
		{ KVC_6,			"6" },
		{ KVC_7,			"7" },
		{ KVC_8,			"8" },
		{ KVC_9,			"9" },
		{ KVC_0,			"0" },
		
		{ KVC_A,			"A" },
		{ KVC_B,			"B" },
		{ KVC_C,			"C" },
		{ KVC_D,			"D" },
		{ KVC_E,			"E" },
		{ KVC_F,			"F" },
		{ KVC_G,			"G" },
		{ KVC_H,			"H" },
		{ KVC_I,			"I" },
		{ KVC_J,			"J" },
		{ KVC_K,			"K" },
		{ KVC_L,			"L" },
		{ KVC_M,			"M" },
		{ KVC_N,			"N" },
		{ KVC_O,			"O" },
		{ KVC_P,			"P" },
		{ KVC_Q,			"Q" },
		{ KVC_R,			"R" },
		{ KVC_S,			"S" },
		{ KVC_T,			"T" },
		{ KVC_U,			"U" },
		{ KVC_V,			"V" },
		{ KVC_W,			"W" },
		{ KVC_X,			"X" },
		{ KVC_Y,			"Y" },
		{ KVC_Z,			"Z" },
		
		{ KVC_F1,			"F1" },
		{ KVC_F2,			"F2" },
		{ KVC_F3,			"F3" },
		{ KVC_F4,			"F4" },
		{ KVC_F5,			"F5" },
		{ KVC_F6,			"F6" },
		{ KVC_F7,			"F7" },
		{ KVC_F8,			"F8" },
		{ KVC_F9,			"F9" },
		{ KVC_F10,			"F10" },
		{ KVC_F11,			"F11" },
		{ KVC_F12,			"F12" },
		
		{ KVC_MINUS,		"-" },
		{ KVC_CARET,		"^" },
		{ KVC_BACKSPACE,	"BackSpace" },
		{ KVC_AT,			"@" },
		{ KVC_LBRACKET,		"[" },
		{ KVC_SEMICOLON,	";" },
		{ KVC_COLON,		":" },
		{ KVC_COMMA,		"," },
		{ KVC_PERIOD,		"." },
		{ KVC_SLASH,		"/" },
		{ KVC_SPACE,		"Space" },
		
		{ KVC_ESC,			"ESC" },
		{ KVC_HANZEN,		"p/Sp" },
		{ KVC_TAB,			"Tab" },
		{ KVC_CAPSLOCK,		"CapsLock" },
		{ KVC_ENTER,		"Enter" },
		{ KVC_LCTRL,		"L-Ctrl" },
		{ KVC_RCTRL,		"R-Ctrl" },
		{ KVC_LSHIFT,		"L-Shift" },
		{ KVC_RSHIFT,		"R-Shift" },
		{ KVC_LALT,			"L-Alt" },
		{ KVC_RALT,			"R-Alt" },
		{ KVC_PRINT,		"PrintScreen" },
		{ KVC_SCROLLLOCK,	"ScrollLock" },
		{ KVC_PAUSE,		"Pause" },
		{ KVC_INSERT,		"Insert" },
		{ KVC_DELETE,		"Delete" },
		{ KVC_END,			"End" },
		{ KVC_HOME,			"Home" },
		{ KVC_PAGEUP,		"PageUp" },
		{ KVC_PAGEDOWN,		"PageDown" },
		
		{ KVC_UP,			"" },
		{ KVC_DOWN,			"" },
		{ KVC_LEFT,			"" },
		{ KVC_RIGHT,		"" },
		
		{ KVC_P0,			"0(eL[)" },
		{ KVC_P1,			"1(eL[)" },
		{ KVC_P2,			"2(eL[)" },
		{ KVC_P3,			"3(eL[)" },
		{ KVC_P4,			"4(eL[)" },
		{ KVC_P5,			"5(eL[)" },
		{ KVC_P6,			"6(eL[)" },
		{ KVC_P7,			"7(eL[)" },
		{ KVC_P8,			"8(eL[)" },
		{ KVC_P9,			"9(eL[)" },
		{ KVC_NUMLOCK,		"NumLock" },
		{ KVC_P_PLUS,		"+(eL[)" },
		{ KVC_P_MINUS,		"-(eL[)" },
		{ KVC_P_MULTIPLY,	"*(eL[)" },
		{ KVC_P_DIVIDE,		"/(eL[)" },
		{ KVC_P_PERIOD,		".(eL[)" },
		{ KVC_P_ENTER,		"Enter(eL[)" },
		
		// {L[{[ĥ
		{ KVC_YEN,			"\\" },
		{ KVC_RBRACKET,		"]" },
		{ KVC_UNDERSCORE,	"_" },
		{ KVC_MUHENKAN,		"ϊ" },
		{ KVC_HENKAN,		"ϊ" },
		{ KVC_HIRAGANA,		"Ђ炪" },
		
		// pL[{[ĥ
		{ KVE_BACKSLASH,	"BackSlash" },
		
		// ǉL[
		{ KVX_RMETA,		"L-Command" /*"L-Windows"*/ },
		{ KVX_LMETA,		"R-Command" /*"R-Windows"*/ },
		{ KVX_MENU,			"Menu" }
	};
	
	char *str = NULL;
	/*        FIX ME!  compiler error
	
	src/osdMac.cpp: In function 'const char* OSD_KeyName(PCKEYsym)':
    src/osdMac.cpp:1266: error: invalid conversion from 'const char* const' to 'char*'

	for( int i=0; i<(int)(sizeof(kname)/sizeof(PCKeyName)); i++ ){
		if( kname[i].PCKey == sym ){
			str = kname[i].Name;
			break;
		}
	}
	*/
	return str;
}


////////////////////////////////////////////////////////////////
// tHgt@C쐬
//
// :	hfile		ptHgt@CpX
//			zfile		SptHgt@CpX
//			size		TCY(psNZ)
// Ԓl:	BOOL		TRUE:쐬 FALSE:쐬s
////////////////////////////////////////////////////////////////
BOOL OSD_CreateFont( char *hfile, char *zfile, int size )
{
	int Wscr = size * 96 * 2;
	int Hscr = size * 96 * 2;


#ifdef __APPLE__
	// this part is written by Koichi Nishida 2004/10/11, 2005/1/23
	
	int i;
	
	// ̃CfbNXJ[gp

	// SDL ̃J[e[u
	SDL_Color sdlCols[2] = {{ 0x0000, 0x0000, 0x0000, 0x0000 }, { 0xffff, 0xffff, 0xffff, 0x0000 }};
    
	// QuickDraw ̃ItXN[̃J[e[u
	int colorNum = 2;
	RGBColor black = { 0x0000, 0x0000, 0x0000 };
	RGBColor white = { 0xffff, 0xffff, 0xffff };
	CTabHandle gCTable = (CTabHandle)NewHandle( sizeof(ColorTable) + colorNum * sizeof(ColorSpec) );
	// RGB J[ł͂ȂCfbNXJ[gp鎖B
	(**gCTable).ctFlags |= 0x4000;
	// V[h́Aӂ̐łȂ΂ȂȂB
	(**gCTable).ctSeed = GetCTSeed();
	// J[e[u	
	(**gCTable).ctSize = colorNum;
	(**gCTable).ctTable[0].value = 0;
	(**gCTable).ctTable[0].rgb = black;
	(**gCTable).ctTable[1].value = 1;
	(**gCTable).ctTable[1].rgb = white;

	Rect rect;    
	SetRect( &rect, 0, 0, Wscr, Hscr );
	//                      ^     ^
	//                    E̍W+1
	
	// ItXN[ GWorld B
	GWorldPtr OffGw;
	NewGWorld( &OffGw, 8, &rect, gCTable, NULL, 0 );

	// ItXN[ɃtH[JX𓖂ĂB
	GWorldPtr gptrSave;
	GDHandle ghdSave;
	GetGWorld( &gptrSave, &ghdSave ); // ݂̃tH[JXZ[u
	SetGWorld( OffGw, NULL );

	// ItXN[obt@ւ̃|C^𓾂B
	PixMapHandle pm = GetGWorldPixMap( OffGw );
	BYTE* ppixel = (BYTE*)GetPixBaseAddr( pm );
	int rowBytes = ((**pm).rowBytes & 0x3fff);

	// tHgpϐ
	short fontNum;
	Str15 fontName; // 15̃pXJiŏ̃oCgɕĂ镶j

	// `Fݒ肵AItXN[NAB
	RGBForeColor( &white );
	RGBBackColor( &black );
	EraseRect( &rect );

	// tHg`
	BYTE strk[3] = { 0x00, 0x00, 0x00 };
	Str15 strkp;
	// p
	CopyCStringToPascal("Courier", fontName );
	GetFNum( fontName, &fontNum );
	TextFont( fontNum );
	TextSize( 10 );
	
	if( hfile ){
		for( int y=0; y<2; y++ ){
			for( int x=32; x<128; x++ ){
				strk[0] = x + y * 128;
				CopyCStringToPascal( (char*)strk, strkp );
				MoveTo( x*size, y*size*2 + size*2-2 );
				//                         ~~~~~~~~
                //                             ^
                //           ۂɂ y W "" ɕ\邽߁B
				//
				DrawString( strkp );
			}
		}
		// ItXN[obt@tbVB
		QDFlushPortBuffer( OffGw, GetPortVisibleRegion(OffGw, NewRgn()) );
		SDL_Surface *FFont = SDL_CreateRGBSurface(
			SDLOP_SURFACE | SDL_SRCCOLORKEY, Wscr, size*2*2, 8, 0, 0, 0, 0 );
		// rowBytes l 1 CÃRs[
		for( i=0; i<size*2*2; i++, ppixel+=rowBytes )
			memcpy( (BYTE *)FFont->pixels + Wscr*i, ppixel, Wscr );

		SDL_SetColors( FFont, sdlCols, 0, 2 );
		SavePNG( hfile, FFont ,NULL);
		SDL_FreeSurface( FFont );
	}

	EraseRect(&rect);

	// Sp
	CopyCStringToPascal( "Osaka", fontName ); // Sp Osaka tHg 
	GetFNum( fontName, &fontNum );
	TextFont( fontNum );
	TextSize( 10 );
	if( zfile ){
		for( int y=1; y<95; y++ ){
			for( int x=1; x<95; x++ ){
				strk[0] = y + 0x20;
				strk[1] = x + 0x20;
				Jis2Sjis( &strk[0], &strk[1] );
				CopyCStringToPascal( (char*)strk, strkp );
				MoveTo( x*size*2, y*size*2 + size*2-2 );
				//                           ~~~~~~~~
                //                              ^
                //            ۂɂ y W "" ɕ\邽߁B
				//
				DrawString(strkp);
			}
		}
		// ItXN[obt@tbVB
		QDFlushPortBuffer( OffGw, GetPortVisibleRegion( OffGw, NewRgn()) );
		SDL_Surface *FFont = SDL_CreateRGBSurface(
			SDLOP_SURFACE | SDL_SRCCOLORKEY, Wscr, Hscr, 8, 0, 0, 0, 0 );
		// rowBytes l 1 CÃRs[
		for( i=0; i<Hscr; i++, ppixel+=rowBytes )
			memcpy( (BYTE *)FFont->pixels + Wscr*i, ppixel, Wscr );

		SDL_SetColors( FFont, sdlCols, 0, 2 );
		SavePNG( zfile, FFont ,NULL );
		SDL_FreeSurface( FFont );
	}

	// tH[JX߂B
	SetGWorld( gptrSave, ghdSave );
	// ItXN[
	DisposeGWorld(OffGw);
	// J[e[u
	DisposeHandle((Handle)gCTable);
	return TRUE;
#endif
}


///////////////////////////////////////////////////////////////
// R[h`ϊ(UTF8 -> SJIS)
//
// :	src				\[X̃|C^
// Ԓl:	
////////////////////////////////////////////////////////////////
char* OSD_UTF8toSJIS( const char *src )
{
	static char dst[PATH_MAX];
	CFStringRef cfstr;
	
	cfstr = CFStringCreateWithCString( NULL, src, kCFStringEncodingUTF8 );
	CFStringGetCString( cfstr, dst, PATH_MAX, kCFStringEncodingShiftJIS_X0213_00 );
	CFRelease( cfstr );
	return dst;
}

///////////////////////////////////////////////////////////////
// R[h`ϊ(SJIS -> UTF8)
//
// :	src				\[X̃|C^
// Ԓl:	
////////////////////////////////////////////////////////////////
char* OSD_SJIStoUTF8( const char *src )
{
	static char dst[PATH_MAX];
	CFStringRef cfstr;
	
	cfstr = CFStringCreateWithCString( NULL, src, kCFStringEncodingShiftJIS_X0213_00 );
	CFStringGetCString( cfstr, dst, PATH_MAX, kCFStringEncodingUTF8 );
	CFRelease( cfstr );
	return dst;
}

//FILE* OSD_fopen(const char *path , const char *mode)
//{
//	return( fopen( SJIStoUTF8(path),mode));
//}


////////////////////////////////////////////////////////////////
// t@C̓ǎp`FbN
//
// :	path		tpXi[obt@|C^
// Ԓl:	BOOL		TRUE:ǎp FALSE:ǂݏ
///////////////////////////////////////////////////////////////
BOOL OSD_FileReadOnly( const char *fullpath )
{
/*    Ver.1.11 @@@UnixpɁA蒼ƁII@windy

	PRINTD( OSD_LOG, "[OSD][OSD_FileReadOnly]\n" );
	
	char filename[PATH_MAX+1];
	
	strncpy( filename, fullpath, PATH_MAX );
	
	DelDelimiter( filename );
	UnDelimiter( filename );
	
	DWORD fa = GetFileAttributes( filename );
	
	if( fa & FILE_ATTRIBUTE_READONLY ) return TRUE;
	else                               return FALSE;
*/
    return FALSE;
}


